import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * Artificial intelligence. Commands all units under the assigned player.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class AI  extends Actor
{
    private static final int EvilBabyCorporation = 2;
    private static final int TerritorialIndependenceArmy = 1;
    private static final int PosterityofSentinels = 3;
    public Battleground Mache;
    private WorldArray wa;
    public int side;
    /**
     * AI Type. This will determine what the AI will try to produce. For example, an offensive AI will try to stick with Squad 1 and Squad 2 units, while guerilla AI will prefer Squad 4 units.
     * 0- Tutorial 1- Offensive 2- Economic 3- Tech 4- Guerilla 5- Shock 6- Steamroll
     * Tutorial AI- Easy, builds only basic infantry and takes only 1 refinery.
     * Offensive AI- The stereotypical "brute" AI, prefers infantry en masse and MBTs. Slow tech, slow expansion, and some shock units.
     * Economic AI- This AI will attempt to expand quickly and will try to gain high income rates. Unit production will be much like the Offensive AI, although the build will be towards cheap units and some shock units over MBTs.
     * Tech AI- This AI will attempt to go up the tech tree at a quick but safe pace. Will tend to prefer higher quality units, and will upgrade most liberally.
     * Guerilla AI- This AI will prefer fast units, and attempt to disrupt the enemy economy. Attacks most often.
     * Shock AI- This AI prefers specialized units (Squad 3 units), and prefers
     * Steamroll AI- Prefers MBT. Likes to expand and likes vehicles over infantry.
     */
    public int behavior;
    public int faction;
    private int armystrength;
    //Squads that the AI will send commands to.
    /**
     * Squad 1: The main frontline forces. Comprised of average speed units and are largely meat shield, especially with EBC.
     */
    public ArrayList<Units> squad1 = new ArrayList<Units>();
    /**
     * Squad 2: The long range support: Most of them have explosive weapons, and often are not as sturdy as Squad 1 forces but deal more damage.
     */
    public ArrayList<Units> squad2 = new ArrayList<Units>();
    /**
     * Squad 3: The specialized shock troopers, used to take out enemy quickly but often have several drawbacks: Good examples are the two higher end EBC infantry, Ninjas, and tank destroyers: Sometimes these are fast.
     */
    public ArrayList<Units> squad3 = new ArrayList<Units>();
    /**
     * Squad 4: Fast firefighting units: e.g. Sphere Hovercycle
     */
    public ArrayList<Units> squad4 = new ArrayList<Units>();
    /**
     * Squad 5: Garrison. If the army size reaches a certain proportion some units are diverted to exclusively defend.
     */
    public ArrayList<Units> squad5 = new ArrayList<Units>();
    /**
     * Attack Squad: Instead of devoting all the troops into battle, sometimes an attack squad diverts only some of the units into an attack.
     */
    public ArrayList<Units> attackSquad = new ArrayList<Units>();
    /**
     * Units
     * 1- Volunteer Sphere 2-Rocket Spheres 3-Ninja 4-Standard Armor 5-Gun Tank 6-Tank Destroyer 7-Airborne Drone 8-Napalm Bomber 9-Worker Sphere 19-Sphere Hovercycle
     * 10- Pistol Baby 11-Grenadier Baby 12-Explosive Baby 14-Flamethrower Baby 15-Troop Carrier 16-AA Track 17-Light Tank 18-Worker Baby
     * 20- Posterity MBT 21- Chem Tank 22- Artillery 23- Fighters 24- Light Bombers 25- Mecha Hoplites 26- Floating Disc 27- Harvester
     */
    public int[] units = new int[50];
    public int[] requiredUnits = new int[50];
    public int[] Structures = new int[30];
    public int[] requiredStructures = new int[30];
    private int com;
    private int comu;
    private int xx;
    private int yy;
    private Player ergos;
    private ArrayList<Boolean> argh = new ArrayList<Boolean>();
    private ArrayList<Boolean> arghu = new ArrayList<Boolean>();
    public ArrayList<DestructibleObjects> constructor = new ArrayList<DestructibleObjects>();
    /**
     * The point of the main base for the AI.
     */
    private int[] mainbase = new int[2];
    /**
     * Nearestsource Ore mine
     */
    private OreMine nearestsource;
    /**
     * ArrayList storing intersecting objects for new structures
     */
    private ArrayList<DestructibleObjects> intersect = new ArrayList<DestructibleObjects>();
    private ArrayList<Boolean> newargh = new ArrayList<Boolean>();
    private ArrayList<Boolean> newarghu = new ArrayList<Boolean>();
    private int x1;
    private int x2;
    private int x3;
    private int x4;
    /**
     * x-position of the center of each squads
     */
    private int[] squadx = new int[4];
    /**
     * the desired x-position of the squad.
     */
    private int[] squadorderx = new int[4];
    /**
     * Formation of each squad
     * 1- Upper flank square
     * 2- Lower flank square
     * 3- Battle Line rectangular
     * 4- Battle Line wedge
     * 5- Battle Line reverse wedge
     * 6- Upper flank wedge
     * 7- Lower flank wedge
     */
    private int[] squadformation = new int[4];
    /**
     * The row that is the least occupied (and thus the weakest)
     */
    private int[] leastrow = new int[4];
    private boolean move = true;
    /**
     * Stores the units that are supposed to be in each row, by each nongarrison rows.
     */
    public ArrayList<ArrayList<ArrayList<Units>>> r = new ArrayList<ArrayList<ArrayList<Units>>>();
    /**
     * Reserve units for each squad. If the reserve unit count is 0, then the AI does not keep shuffling units.
     */
    public ArrayList<ArrayList<Units>> reserve = new ArrayList<ArrayList<Units>>();
    /**
     * Average row size. Rounds up.
     */
    private int[] avgsize = new int[4];
    /**
     * Total Attack: if true, the AI will divert ALL combat units to attack.
     */
    private boolean totatt;
    /**
     * Delay until attack
     */
    private int delay;
    public AI(int race, int AItype, int iniside, Player owner)
    {
        faction = race;
        behavior = AItype;
        side = iniside;
        ergos = owner;
    }

    public void addedToWorld(World w)
    {
        Mache = (Battleground) w;
        wa = Mache.array;
        for(int i = 0; i < 11; i++)
        {
            ArrayList<ArrayList<Units>> a = new ArrayList<ArrayList<Units>>();
            for(int j = 0; j < 4; j++)
            {
                ArrayList<Units> b = new ArrayList<Units>();
                a.add(b);
            }
            r.add(a);
        }
        for(int i = 0; i < 4; i++)
        {
            ArrayList<Units> c = new ArrayList<Units>();
            reserve.add(c);
        }
        leastrow[0] = 12;
        leastrow[1] = 12;
        leastrow[2] = 12;
        leastrow[3] = 12;
    }

    /**
     * Act: AI first stores all units that the player owns in an array. Then it checks requirements and adds to requirements whenever the requirements are met.
     */
    public void act() 
    {
        // Add your action code here.
        try
        {
            if(Mache.bd != null)
            {
                if(Mache.bd.getWorld() != null)
                {
                    switch(side)
                    {
                        case 1:
                        setSquadFront(Mache.bd.realX(), 0);
                        setSquadFront(Mache.bd.realX() - 300, 1);
                        setSquadFront(Mache.bd.realX() + 100, 2);
                        setSquadFront(Mache.bd.realX() + 400, 3);
                        break;
                        case 2:
                        setSquadFront(Mache.bd.realX(), 0);
                        setSquadFront(Mache.bd.realX() + 300, 1);
                        setSquadFront(Mache.bd.realX() - 100, 2);
                        setSquadFront(Mache.bd.realX() - 400, 3);
                        break;
                    }
                }
            }
            if(delay > 0)
            {
                delay --;
            }
            refreshX();
            advance();
            advanceunit();
            takeAverage();
            drawBattleLine();
            defend();
            for(OreMine p : wa.ResourceSource)
            {
                if(nearestsource == null)
                {
                    nearestsource = p;
                }
                if((Math.sqrt(Math.pow(nearestsource.realX() - mainbase[0], 2) + Math.pow(nearestsource.realY() - mainbase[1], 2)) > Math.sqrt(Math.pow(p.realX() - mainbase[0], 2) + Math.pow(p.realY() - mainbase[1], 2)) && !p.occupied) || (nearestsource.occupied && !p.occupied))
                {
                    nearestsource = p;
                }
            }
            for(Units a : wa.Taxeis)
            {
                if(a.getOwner() == ergos && !a.AIcount)
                {
                    a.AIcount = true;
                    a.ai = this;
                    units[a.id] ++;
                }
            }
            for(Structures b : wa.Aedificium)
            {
                if(b.getOwner() == ergos && !b.AIcount)
                {
                    b.AIcount = true;
                    b.ai = this;
                    Structures[b.id] ++;
                }
                //Some strikes are automatically used, regardless of factions.
                //EBC Free supplies
                if(b instanceof CapitalistLodge && b.getOperational() && b.getOwner() == ergos)
                {
                    if(b.buttoncooldown.get(0) <= 0)
                    {
                        b.getOwner().resources += 250;
                        b.buttoncooldown.set(0, 2500);
                    }
                }
                //Posterity Airstrike
                if(b instanceof CommandPost && b.getOperational() && b.getOwner() == ergos)
                {
                    if(b.buttoncooldown.get(0) <= 0)
                    {
                        int largest = 0;
                        int r[] = new int[11];
                        for(Units c : wa.Taxeis)
                        {
                            try
                            {
                                r[c.getRow()]++;
                            }
                            catch(IndexOutOfBoundsException e)
                            {
                            }
                            try
                            {
                                if(r[c.getRow()] > r[largest])
                                {
                                    largest = c.getRow();
                                }
                            }
                            catch(IllegalArgumentException e)
                            {
                            }
                        }
                        switch(b.getSide())
                        {
                            case 1: getWorld().addObject(new Fighter(1, 2, (largest * 40) - 10), 2, (largest * 40) - 10); getWorld().addObject(new Fighter(1, 2, (largest * 40) + 10), 2, (largest * 40) + 10); break;
                            case 2: getWorld().addObject(new Fighter(2, (int) wa.getWidth() - 2, (largest * 40) - 10), (int) wa.getWidth() - 2, (largest * 40) - 10); getWorld().addObject(new Fighter(2, (int) wa.getWidth() - 2, (largest * 40) + 10), (int) wa.getWidth() - 2, (largest * 40) + 10); break;
                        }
                        b.buttoncooldown.set(0, 1000);
                    }
                }
            }
            //ALL AI OBEYS COSTS AND TECHTREE REQUIREMENTS!
            //Territorial Independence Army
            if(faction == TerritorialIndependenceArmy)
            {
                //Unpacks a Construction Hub Carrier at the base. (Originally named MCV after the counterparts in C&C series)
                for(Units a : wa.Taxeis)
                {
                    if(a.getOwner() == ergos && a instanceof MobileConstructionVehicle)
                    {
                        if(Math.abs(a.realX() - mainbase[0]) < 4 && Math.abs(a.realY() - mainbase[1]) < 4)
                        {
                            a.setBehavior(7);
                        }
                    }
                }
                for(Structures a : wa.Aedificium)
                {
                    if(a.getOwner() == ergos && a instanceof ConstructionYard && !constructor.contains(a))
                    {
                        ConstructionYard c = (ConstructionYard) a;
                        if(c.getProduction() == 0)
                        {
                            constructor.add(a);
                        }
                    }
                }
                xx = Greenfoot.getRandomNumber(300);
                int yy = Greenfoot.getRandomNumber(300);
                xx -= Greenfoot.getRandomNumber(300);
                yy -= Greenfoot.getRandomNumber(300);
                if(intersect.size() > 0)
                {
                    intersect.clear();
                    xx = Greenfoot.getRandomNumber(300);
                    yy = Greenfoot.getRandomNumber(300);
                    xx -= Greenfoot.getRandomNumber(300);
                    yy -= Greenfoot.getRandomNumber(300);
                }
                //Builds TIA Refinery
                if(requiredStructures[1] > Structures[1])
                {
                    try
                    {
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 0 && ergos.resources >= 400)
                        {
                            ergos.resources -= 400;
                            ((ConstructionYard)constructor.get(0)).setProdMax(900);
                            ((ConstructionYard)constructor.get(0)).setProduction(1);
                        }
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 1 && ((ConstructionYard)constructor.get(0)).getProgress() >= 1)
                        {
                            Refinery a = new Refinery(ergos.getSide(), ergos, 0, 0);
                            if(side == 1)
                            {
                                a.setRealLocation(nearestsource.realX() - 200, nearestsource.realY());
                            }
                            else if(side == 2)
                            {
                                a.setRealLocation(nearestsource.realX() + 200, nearestsource.realY());
                            }
                            if(a.realY() < 30)
                            {
                                a.setRealLocation(a.realX(), 30);
                            }
                            if(a.realY() > 410)
                            {
                                a.setRealLocation(a.realX(), 410);
                            }
                            getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                            ((ConstructionYard)constructor.get(0)).clearProduction();
                        }
                    }
                    catch(IndexOutOfBoundsException e)
                    {
                    }
                }
                //builds Dojo
                if(requiredStructures[2] > Structures[2])
                {
                    try
                    {
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 0 && ergos.resources >= 100)
                        {
                            ergos.resources -= 100;
                            ((ConstructionYard)constructor.get(0)).setProdMax(400);
                            ((ConstructionYard)constructor.get(0)).setProduction(2);
                        }
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 2 && ((ConstructionYard)constructor.get(0)).getProgress() >= 1)
                        {
                            Dojo a = new Dojo(ergos.getSide(), ergos, 0, 0);
                            xx = Greenfoot.getRandomNumber(300);
                            yy = Greenfoot.getRandomNumber(300);
                            xx -= Greenfoot.getRandomNumber(300);
                            yy -= Greenfoot.getRandomNumber(300);
                            a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                            if(a.realY() < 30)
                            {
                                a.setRealLocation(a.realX(), 30);
                            }   
                            if(a.realY() > 410)
                            {
                                a.setRealLocation(a.realX(), 410);
                            }
                            for(DestructibleObjects b : wa.Actors)
                            {
                                if(mainbase[1]+yy >= 30 && mainbase[1]+yy <= 410)
                                {
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+30) && b.realY()+b.getImage().getHeight() > (mainbase[1]+yy-30) && b.realY()-b.getImage().getHeight() < (mainbase[1]+yy+30))
                                    {
                                        intersect.add(b);
                                    }
                                }
                                else
                                {
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+30) && b.realY()+b.getImage().getHeight() > 0 && b.realY()-b.getImage().getHeight() < 60 && mainbase[1]+yy >= 30)
                                    {
                                        intersect.add(b);
                                    }
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+380) && b.realY()+b.getImage().getHeight() > 0 && b.realY()-b.getImage().getHeight() < 440 && mainbase[1]+yy >= 410)
                                    {
                                        intersect.add(b);
                                    }
                                }
                            }
                            if(intersect.size() <= 0)
                            {
                                getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                                ((ConstructionYard)constructor.get(0)).clearProduction();
                            }
                            else
                            {
                                xx = Greenfoot.getRandomNumber(300);
                                yy = Greenfoot.getRandomNumber(300);
                                xx -= Greenfoot.getRandomNumber(300);
                                yy -= Greenfoot.getRandomNumber(300);
                                a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                            }
                        }
                    }
                    catch(IndexOutOfBoundsException e)
                    {
                    }
                }
                //builds War Factory
                if(requiredStructures[3] > Structures[3])
                {
                    try
                    {
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 0 && ergos.resources >= 400)
                        {
                            ergos.resources -= 400;
                            ((ConstructionYard)constructor.get(0)).setProdMax(1600);
                            ((ConstructionYard)constructor.get(0)).setProduction(3);
                        }
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 3 && ((ConstructionYard)constructor.get(0)).getProgress() >= 1)
                        {
                            TIAWarFactory a = new TIAWarFactory(ergos.getSide(), ergos, 0, 0);
                            xx = Greenfoot.getRandomNumber(300);
                            yy = Greenfoot.getRandomNumber(300);
                            xx -= Greenfoot.getRandomNumber(300);
                            yy -= Greenfoot.getRandomNumber(300);
                            a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                            if(a.realY() < 30)
                            {
                                a.setRealLocation(a.realX(), 30);
                            }   
                            if(a.realY() > 410)
                            {
                                a.setRealLocation(a.realX(), 410);
                            }
                            for(DestructibleObjects b : wa.Actors)
                            {
                                if(mainbase[1]+yy >= 30 && mainbase[1]+yy <= 410)
                                {
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+30) && b.realY()+b.getImage().getHeight() > (mainbase[1]+yy-30) && b.realY()-b.getImage().getHeight() < (mainbase[1]+yy+30))
                                    {
                                        intersect.add(b);
                                    }
                                }
                                else
                                {
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+30) && b.realY()+b.getImage().getHeight() > 0 && b.realY()-b.getImage().getHeight() < 60 && mainbase[1]+yy >= 30)
                                    {
                                        intersect.add(b);
                                    }
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+380) && b.realY()+b.getImage().getHeight() > 0 && b.realY()-b.getImage().getHeight() < 440 && mainbase[1]+yy >= 410)
                                    {
                                        intersect.add(b);
                                    }
                                }
                            }
                            if(intersect.size() <= 0)
                            {
                                getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                                ((ConstructionYard)constructor.get(0)).clearProduction();
                            }
                            else
                            {
                                xx = Greenfoot.getRandomNumber(300);
                                yy = Greenfoot.getRandomNumber(300);
                                xx -= Greenfoot.getRandomNumber(300);
                                yy -= Greenfoot.getRandomNumber(300);
                                a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                            }
                        }
                    }
                    catch(IndexOutOfBoundsException e)
                    {
                    }
                }
                //builds Airstrip
                if(requiredStructures[4] > Structures[4])
                {
                    try
                    {
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 0 && ergos.resources >= 200)
                        {
                            ergos.resources -= 200;
                            ((ConstructionYard)constructor.get(0)).setProdMax(800);
                            ((ConstructionYard)constructor.get(0)).setProduction(4);
                        }
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 4 && ((ConstructionYard)constructor.get(0)).getProgress() >= 1)
                        {
                            Airfield a = new Airfield(ergos.getSide(), ergos, 0, 0);
                            xx = Greenfoot.getRandomNumber(300);
                            yy = Greenfoot.getRandomNumber(300);
                            xx -= Greenfoot.getRandomNumber(300);
                            yy -= Greenfoot.getRandomNumber(300);
                            a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                            if(a.realY() < 30)
                            {
                                a.setRealLocation(a.realX(), 30);
                            }   
                            if(a.realY() > 410)
                            {
                                a.setRealLocation(a.realX(), 410);
                            }
                            for(DestructibleObjects b : wa.Actors)
                            {
                                if(mainbase[1]+yy >= 30 && mainbase[1]+yy <= 410)
                                {
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+30) && b.realY()+b.getImage().getHeight() > (mainbase[1]+yy-30) && b.realY()-b.getImage().getHeight() < (mainbase[1]+yy+30))
                                    {
                                        intersect.add(b);
                                    }
                                }
                                else
                                {
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+30) && b.realY()+b.getImage().getHeight() > 0 && b.realY()-b.getImage().getHeight() < 60 && mainbase[1]+yy >= 30)
                                    {
                                        intersect.add(b);
                                    }
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+380) && b.realY()+b.getImage().getHeight() > 0 && b.realY()-b.getImage().getHeight() < 440 && mainbase[1]+yy >= 410)
                                    {
                                        intersect.add(b);
                                    }
                                }
                            }
                            if(intersect.size() <= 0)
                            {
                                getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                                ((ConstructionYard)constructor.get(0)).clearProduction();
                            }
                            else
                            {
                                xx = Greenfoot.getRandomNumber(300);
                                yy = Greenfoot.getRandomNumber(300);
                                xx -= Greenfoot.getRandomNumber(300);
                                yy -= Greenfoot.getRandomNumber(300);
                                a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                            }
                        }
                    }
                    catch(IndexOutOfBoundsException e)
                    {
                    }
                }
                //builds StrategyCenter
                if(requiredStructures[5] > Structures[5])
                {
                    try
                    {
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 0 && ergos.resources >= 400)
                        {
                            ergos.resources -= 400;
                            ((ConstructionYard)constructor.get(0)).setProdMax(2000);
                            ((ConstructionYard)constructor.get(0)).setProduction(5);
                        }
                        if(((ConstructionYard)constructor.get(0)).getProduction() == 5 && ((ConstructionYard)constructor.get(0)).getProgress() >= 1)
                        {
                            StrategyCenter a = new StrategyCenter(ergos.getSide(), ergos, 0, 0);
                            xx = Greenfoot.getRandomNumber(300);
                            yy = Greenfoot.getRandomNumber(300);
                            xx -= Greenfoot.getRandomNumber(300);
                            yy -= Greenfoot.getRandomNumber(300);
                            a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                            if(a.realY() < 30)
                            {
                                a.setRealLocation(a.realX(), 30);
                            }   
                            if(a.realY() > 410)
                            {
                                a.setRealLocation(a.realX(), 410);
                            }
                            for(DestructibleObjects b : wa.Actors)
                            {
                                if(mainbase[1]+yy >= 30 && mainbase[1]+yy <= 410)
                                {
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+30) && b.realY()+b.getImage().getHeight() > (mainbase[1]+yy-30) && b.realY()-b.getImage().getHeight() < (mainbase[1]+yy+30))
                                    {
                                        intersect.add(b);
                                    }
                                }
                                else
                                {
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+30) && b.realY()+b.getImage().getHeight() > 0 && b.realY()-b.getImage().getHeight() < 60 && mainbase[1]+yy >= 30)
                                    {
                                        intersect.add(b);
                                    }
                                    if(b.realX()+b.getImage().getWidth() < (mainbase[0]+xx-30) && b.realX()-b.getImage().getWidth() > (mainbase[0]+xx+380) && b.realY()+b.getImage().getHeight() > 350 && b.realY()-b.getImage().getHeight() < 440 && mainbase[1]+yy >= 410)
                                    {
                                        intersect.add(b);
                                    }
                                }
                            }
                            if(intersect.size() <= 0)
                            {
                                getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                                ((ConstructionYard)constructor.get(0)).clearProduction();
                            }
                            else
                            {
                                xx = Greenfoot.getRandomNumber(300);
                                yy = Greenfoot.getRandomNumber(300);
                                xx -= Greenfoot.getRandomNumber(300);
                                yy -= Greenfoot.getRandomNumber(300);
                                a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                            }
                        }
                    }
                    catch(IndexOutOfBoundsException e)
                    {
                    }
                }
                //Upgrades Dojo when Idle
                if(ergos.Requirements[5] > 0)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof Dojo)
                        {
                            Dojo b = (Dojo) a;
                            if(!b.upgraded)
                            {
                                ergos.resources -= 50;
                                b.setProdMax(600);
                                b.setProduction(11);
                            }
                        }
                    }
                }
                //Upgrades AP Rockets
                if(comu >= 6)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof Dojo && ergos.Upgrades[2] <= 0)
                        {
                            ergos.resources -= 50;
                            a.setProdMax(400);
                            a.setProduction(10);
                        }
                    }
                }
                if(requiredUnits[1] > units[1] && ergos.resources >= 25)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof Dojo)
                        {
                            ergos.resources -= 25;
                            a.setAIProduction(1);
                        }
                    }
                }
                if(requiredUnits[2] > units[2] && ergos.resources >= 40)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof Dojo)
                        {
                            ergos.resources -= 40;
                            a.setAIProduction(2);
                        }
                    }
                }
                if(requiredUnits[3] > units[3] && ergos.resources >= 110)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof Dojo)
                        {
                            Dojo b = (Dojo) a;
                            if(b.upgraded)
                            {
                                ergos.resources -= 110;
                                a.setAIProduction(3);
                            }
                        }
                    }
                }
                if(requiredUnits[4] > units[4] && ergos.resources >= 140)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof TIAWarFactory)
                        {
                            ergos.resources -= 140;
                            a.setAIProduction(4);
                        }
                    }
                }
                if(requiredUnits[5] > units[5] && ergos.resources >= 110)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof TIAWarFactory)
                        {
                            ergos.resources -= 110;
                            a.setAIProduction(5);
                        }
                    }
                }
                if(requiredUnits[6] > units[6] && ergos.resources >= 150 && ergos.Requirements[5] > 0)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof TIAWarFactory)
                        {
                            ergos.resources -= 150;
                            a.setAIProduction(6);
                        }
                    }
                }
                if(requiredUnits[7] > units[7] && ergos.resources >= 60)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof Airfield)
                        {
                            ergos.resources -= 60;
                            a.setAIProduction(7);
                        }
                    }
                }
                if(requiredUnits[8] > units[8] && ergos.resources >= 250)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof Airfield)
                        {
                            ergos.resources -= 250;
                            a.setAIProduction(8);
                        }
                    }
                }
                if(requiredUnits[19] > units[19] && ergos.resources >= 70)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof TIAWarFactory)
                        {
                            ergos.resources -= 70;
                            a.setAIProduction(19);
                        }
                    }
                }
                if(requiredUnits[9] > units[9] && ergos.resources >= 50)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof Refinery)
                        {
                            ergos.resources -= 50;
                            a.setAIProduction(9);
                        }
                    }
                }
                if(requiredUnits[33] > units[33] && ergos.resources >= 180)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof Dojo)
                        {
                            Dojo b = (Dojo) a;
                            if(b.upgraded)
                            {
                                ergos.resources -= 180;
                                a.setAIProduction(33);
                            }
                        }
                    }
                }
                //Sends the units to appropritae squads
                //Squad 1: Volunteers, Standard Armor, Modernized Tank
                //Squad 2: Rockets, Gun Tank
                //Squad 3: Ninjas, Tank Destroyer
                //Squad 4: Airborne Drone, Sphere Hovercycle
                //Reserves: unit without assigned rows, excluding certain types of units.
                for(Units a : wa.Taxeis)
                {
                    if(a.getOwner() == ergos && !squad1.contains(a) && (a instanceof VolunteerSphere || a instanceof StandardArmor))
                    {
                        squad1.add(a);
                        if(a.getAssignedRow() == 12)
                        {
                            reserve.get(0).add(a);
                        }
                    }
                    else if(a.getOwner() == ergos && !squad2.contains(a) && (a instanceof RocketSphere || a instanceof GunTank))
                    {
                        squad2.add(a);
                        if(a.getAssignedRow() == 12)
                        {
                            reserve.get(1).add(a);
                        }
                    }
                    else if(a.getOwner() == ergos && !squad3.contains(a) && (a instanceof Ninja || a instanceof TankDestroyer))
                    {
                        squad3.add(a);
                        if(a.getAssignedRow() == 12)
                        {
                            reserve.get(2).add(a);
                        }
                    }
                    else if(a.getOwner() == ergos && !squad4.contains(a) && (a instanceof SphereHoverCycle || a instanceof AirborneDrone))
                    {
                        squad4.add(a);
                        if(a.getAssignedRow() == 12)
                        {
                            reserve.get(3).add(a);
                        }
                    }
                }
            }
            //EBC Faction AI
            if(faction == EvilBabyCorporation)
            {
                //Checks for idle workers
                for(Units a : wa.Taxeis)
                {
                    if(a.getOwner() == ergos && a instanceof WorkerBaby && !constructor.contains(a))
                    {
                        WorkerBaby c = (WorkerBaby) a;
                        if(c.getAction() != 7)
                        {
                            constructor.add(a);
                        }
                    }
                }
                //Checks for working workers
                try
                {
                    for(DestructibleObjects b : constructor)
                    {
                        if(b instanceof WorkerBaby)
                        {
                            WorkerBaby d = (WorkerBaby) b;
                            if(d.getAction() == 7 || d.hitpoints <= 0)
                            {
                                constructor.remove(d);
                            }
                        }
                    }
                }
                catch(ConcurrentModificationException e)
                {
                }
                xx = Greenfoot.getRandomNumber(300);
                yy = Greenfoot.getRandomNumber(300);
                xx -= Greenfoot.getRandomNumber(300);
                yy -= Greenfoot.getRandomNumber(300);
                if(intersect.size() > 0)
                {
                    intersect.clear();
                    xx = Greenfoot.getRandomNumber(300);
                    yy = Greenfoot.getRandomNumber(300);
                    xx -= Greenfoot.getRandomNumber(300);
                    yy -= Greenfoot.getRandomNumber(300);
                }
                //Builds a EBC Refinery if it is needed.
                if(requiredStructures[6] > Structures[6] && ergos.resources >= 300)
                {
                    try
                    {
                        if(constructor.size() > 0)
                        {
                            EBCRefinery a = new EBCRefinery(ergos.getSide(), ergos, 0, 0);
                            if(side == 1)
                            {
                                a.setRealLocation(nearestsource.realX() - 200, nearestsource.realY());
                            }
                            else if(side == 2)
                            {
                                a.setRealLocation(nearestsource.realX() + 200, nearestsource.realY());
                            }
                            if(a.realY() < 30)
                            {
                                a.setRealLocation(a.realX(), 30);
                            }
                            if(a.realY() > 410)
                            {
                                a.setRealLocation(a.realX(), 410);
                            }
                            getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                            for(int i = 0; i < constructor.size(); i++)
                            {
                                if(((WorkerBaby)constructor.get(i)).targetbuilding == null)
                                {
                                    ((WorkerBaby)constructor.get(i)).targetbuilding = a;
                                }
                            }
                            ergos.resources -= 300;
                        }
                    }
                    catch(IndexOutOfBoundsException e)
                    {
                    }
                }
                //Builds a Baby Camp
                if(requiredStructures[7] > Structures[7] && ergos.resources >= 150)
                {

                    for(DestructibleObjects a : wa.Actors)
                    {
                        if(mainbase[1]+yy >= 30 && mainbase[1]+yy <= 410)
                        {
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+30) && a.realY()+a.getImage().getHeight() > (mainbase[1]+yy-30) && a.realY()-a.getImage().getHeight() < (mainbase[1]+yy+30))
                            {
                                intersect.add(a);
                            }
                        }
                        else
                        {
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+30) && a.realY()+a.getImage().getHeight() > 0 && a.realY()-a.getImage().getHeight() < 60 && mainbase[1]+yy >= 30)
                            {
                                intersect.add(a);
                            }
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+380) && a.realY()+a.getImage().getHeight() > 0 && a.realY()-a.getImage().getHeight() < 440 && mainbase[1]+yy >= 410)
                            {
                                intersect.add(a);
                            }
                        }
                    }
                    if(intersect.size() <= 0)
                    {
                        try
                        {
                            if(constructor.size() > 0)
                            {
                                BabyCamp a = new BabyCamp(ergos.getSide(), ergos, mainbase[0]+xx, mainbase[1]+yy);
                                if(intersect.size() <= 0)
                                {
                                    getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                                }
                                else
                                {
                                    xx = Greenfoot.getRandomNumber(300);
                                    yy = Greenfoot.getRandomNumber(300);
                                    xx -= Greenfoot.getRandomNumber(300);
                                    yy -= Greenfoot.getRandomNumber(300);
                                    a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                                }
                                if(a.realY() < 30)
                                {
                                    a.setRealLocation(a.realX(), 30);
                                }
                                if(a.realY() > 410)
                                {
                                    a.setRealLocation(a.realX(), 410);
                                }
                                for(int i = 0; i < constructor.size(); i++)
                                {
                                    if(((WorkerBaby)constructor.get(i)).targetbuilding == null)
                                    {
                                        ((WorkerBaby)constructor.get(i)).targetbuilding = a;
                                    }
                                }
                                ergos.resources -= 150;
                            }
                        }
                        catch(IndexOutOfBoundsException e)
                        {
                        }
                    }
                }
                //Builds a Capitalist Lodge
                if(requiredStructures[8] > Structures[8] && ergos.resources >= 200)
                {

                    for(DestructibleObjects a : wa.Actors)
                    {
                        if(mainbase[1]+yy >= 30 && mainbase[1]+yy <= 410)
                        {
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+30) && a.realY()+a.getImage().getHeight() > (mainbase[1]+yy-30) && a.realY()-a.getImage().getHeight() < (mainbase[1]+yy+30))
                            {
                                intersect.add(a);
                            }
                        }
                        else
                        {
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+30) && a.realY()+a.getImage().getHeight() > 0 && a.realY()-a.getImage().getHeight() < 60 && mainbase[1]+yy >= 30)
                            {
                                intersect.add(a);
                            }
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+380) && a.realY()+a.getImage().getHeight() > 0 && a.realY()-a.getImage().getHeight() < 440 && mainbase[1]+yy >= 410)
                            {
                                intersect.add(a);
                            }
                        }
                    }
                    if(intersect.size() <= 0)
                    {
                        try
                        {
                            if(constructor.size() > 0)
                            {
                                CapitalistLodge a = new CapitalistLodge(ergos.getSide(), ergos, mainbase[0]+xx, mainbase[1]+yy);
                                if(intersect.size() <= 0)
                                {
                                    getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                                }
                                else
                                {
                                    xx = Greenfoot.getRandomNumber(300);
                                    yy = Greenfoot.getRandomNumber(300);
                                    xx -= Greenfoot.getRandomNumber(300);
                                    yy -= Greenfoot.getRandomNumber(300);
                                    a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                                }
                                if(a.realY() < 30)
                                {
                                    a.setRealLocation(a.realX(), 30);
                                }
                                if(a.realY() > 410)
                                {
                                    a.setRealLocation(a.realX(), 410);
                                }
                                for(int i = 0; i < constructor.size(); i++)
                                {
                                    if(((WorkerBaby)constructor.get(i)).targetbuilding == null)
                                    {
                                        ((WorkerBaby)constructor.get(i)).targetbuilding = a;
                                    }
                                }
                                ergos.resources -= 200;
                            }
                        }
                        catch(IndexOutOfBoundsException e)
                        {
                        }
                    }
                }
                //Builds a Materialist Hub
                if(requiredStructures[9] > Structures[9] && ergos.resources >= 250)
                {

                    for(DestructibleObjects a : wa.Actors)
                    {
                        if(mainbase[1]+yy >= 30 && mainbase[1]+yy <= 410)
                        {
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+30) && a.realY()+a.getImage().getHeight() > (mainbase[1]+yy-30) && a.realY()-a.getImage().getHeight() < (mainbase[1]+yy+30))
                            {
                                intersect.add(a);
                            }
                        }
                        else
                        {
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+30) && a.realY()+a.getImage().getHeight() > 0 && a.realY()-a.getImage().getHeight() < 60 && mainbase[1]+yy >= 30)
                            {
                                intersect.add(a);
                            }
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+380) && a.realY()+a.getImage().getHeight() > 0 && a.realY()-a.getImage().getHeight() < 440 && mainbase[1]+yy >= 410)
                            {
                                intersect.add(a);
                            }
                        }
                    }
                    if(intersect.size() <= 0)
                    {
                        try
                        {
                            if(constructor.size() > 0)
                            {
                                MaterialistHub a = new MaterialistHub(ergos.getSide(), ergos, mainbase[0]+xx, mainbase[1]+yy);
                                if(intersect.size() <= 0)
                                {
                                    getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                                }
                                else
                                {
                                    xx = Greenfoot.getRandomNumber(300);
                                    yy = Greenfoot.getRandomNumber(300);
                                    xx -= Greenfoot.getRandomNumber(300);
                                    yy -= Greenfoot.getRandomNumber(300);
                                    a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                                }
                                if(a.realY() < 30)
                                {
                                    a.setRealLocation(a.realX(), 30);
                                }
                                if(a.realY() > 410)
                                {
                                    a.setRealLocation(a.realX(), 410);
                                }
                                for(int i = 0; i < constructor.size(); i++)
                                {
                                    if(((WorkerBaby)constructor.get(i)).targetbuilding == null)
                                    {
                                        ((WorkerBaby)constructor.get(i)).targetbuilding = a;
                                    }
                                }
                                ergos.resources -= 250;
                            }
                        }
                        catch(IndexOutOfBoundsException e)
                        {
                        }
                    }
                }
                //Builds a EBC War Factory
                if(requiredStructures[10] > Structures[10] && ergos.resources >= 250)
                {

                    for(DestructibleObjects a : wa.Actors)
                    {
                        if(mainbase[1]+yy >= 30 && mainbase[1]+yy <= 410)
                        {
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+30) && a.realY()+a.getImage().getHeight() > (mainbase[1]+yy-30) && a.realY()-a.getImage().getHeight() < (mainbase[1]+yy+30))
                            {
                                intersect.add(a);
                            }
                        }
                        else
                        {
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+30) && a.realY()+a.getImage().getHeight() > 0 && a.realY()-a.getImage().getHeight() < 60 && mainbase[1]+yy >= 30)
                            {
                                intersect.add(a);
                            }
                            if(a.realX()+a.getImage().getWidth() < (mainbase[0]+xx-30) && a.realX()-a.getImage().getWidth() > (mainbase[0]+xx+380) && a.realY()+a.getImage().getHeight() > 0 && a.realY()-a.getImage().getHeight() < 440 && mainbase[1]+yy >= 410)
                            {
                                intersect.add(a);
                            }
                        }
                    }
                    if(intersect.size() <= 0)
                    {
                        try
                        {
                            if(constructor.size() > 0)
                            {
                                EBCFactory a = new EBCFactory(ergos.getSide(), ergos, mainbase[0]+xx, mainbase[1]+yy);
                                if(intersect.size() <= 0)
                                {
                                    getWorld().addObject(a, a.realX() - Mache.camerachange, a.realY());
                                }
                                else
                                {
                                    xx = Greenfoot.getRandomNumber(300);
                                    yy = Greenfoot.getRandomNumber(300);
                                    xx -= Greenfoot.getRandomNumber(300);
                                    yy -= Greenfoot.getRandomNumber(300);
                                    a.setRealLocation(mainbase[0]+xx, mainbase[1]+yy);
                                }
                                if(a.realY() < 30)
                                {
                                    a.setRealLocation(a.realX(), 30);
                                }
                                if(a.realY() > 410)
                                {
                                    a.setRealLocation(a.realX(), 410);
                                }
                                for(int i = 0; i < constructor.size(); i++)
                                {
                                    if(((WorkerBaby)constructor.get(i)).targetbuilding == null)
                                    {
                                        ((WorkerBaby)constructor.get(i)).targetbuilding = a;
                                    }
                                }
                                ergos.resources -= 250;
                            }
                        }
                        catch(IndexOutOfBoundsException e)
                        {
                        }
                    }
                }
                //Sends unassigned Worker Babies to build neglected buildings.
                for(Structures a : wa.Aedificium)
                {
                    if(a.getOwner() == ergos && !a.getOperational() && !a.isBeingBuilt())
                    {
                        try
                        {
                            if(constructor.size() > 0)
                            {
                                ((WorkerBaby)constructor.get(0)).targetbuilding = a;
                            }
                        }
                        catch(IndexOutOfBoundsException e)
                        {
                        }
                    }
                }
                //Trains a squad of Pistoleer Babies
                if(requiredUnits[10] > units[10] && ergos.resources >= 40)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof BabyCamp && a.getOperational())
                        {
                            ergos.resources -= 40;
                            a.setAIProduction(10);
                        }
                    }
                }
                //Trains Grenadier babies
                if(requiredUnits[11] > units[11] && ergos.resources >= 25)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof BabyCamp && a.getOperational())
                        {
                            ergos.resources -= 25;
                            a.setAIProduction(11);
                        }
                    }
                }
                //Trains Explosive babies
                if(requiredUnits[12] > units[12] && ergos.resources >= 20 && ergos.Requirements[8] > 0)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof BabyCamp && a.getOperational())
                        {
                            ergos.resources -= 20;
                            a.setAIProduction(12);
                        }
                    }
                }
                //Trains Flamethrower babies
                if(requiredUnits[14] > units[14] && ergos.resources >= 55 && ergos.Requirements[9] > 0)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof BabyCamp && a.getOperational())
                        {
                            ergos.resources -= 55;
                            a.setAIProduction(14);
                        }
                    }
                }
                //Trains AA Tracks
                if(requiredUnits[16] > units[16] && ergos.resources >= 75)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof EBCFactory && a.getOperational())
                        {
                            ergos.resources -= 75;
                            a.setAIProduction(16);
                        }
                    }
                }
                //Trains Light Tanks
                if(requiredUnits[17] > units[17] && ergos.resources >= 120)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof EBCFactory && a.getOperational())
                        {
                            ergos.resources -= 100;
                            a.setAIProduction(17);
                        }
                    }
                }
                //Trains a worker baby, should the AI declare for it for resource gathering or should there be no constructors available.
                if(requiredUnits[18] > units[18] && ergos.resources >= 40)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof EBCRefinery && a.getOperational())
                        {
                            ergos.resources -= 40;
                            a.setAIProduction(18);
                        }
                    }
                }
                if(constructor.size() == 0 && ergos.resources >= 40)
                {
                    for(Structures a : wa.Aedificium)
                    {
                        if(a.getOwner() == ergos && a.getProduction() == 0 && a instanceof BabyCamp && a.getOperational())
                        {
                            ergos.resources -= 40;
                            a.setAIProduction(18);
                        }
                    }
                }
                //Sends the units to appropritae squads
                //Squad 1: Pistoleers, Light Tank
                //Squad 2: Grenadiers, AA Track
                //Squad 3: Explosive, Flamethrower
                //Squad 4: Troop Carrier
                //Reserves: unit without assigned rows, excluding certain types of units.
                for(Units a : wa.Taxeis)
                {
                    if(a.getOwner() == ergos && !squad1.contains(a) && (a instanceof PistoleerBaby || a instanceof EBCTank))
                    {
                        squad1.add(a);
                        if(a.getAssignedRow() == 12)
                        {
                            reserve.get(0).add(a);
                        }
                    }
                    else if(a.getOwner() == ergos && !squad2.contains(a) && (a instanceof GrenadierBaby || a instanceof AATrack))
                    {
                        squad2.add(a);
                        if(a.getAssignedRow() == 12)
                        {
                            reserve.get(1).add(a);
                        }
                    }
                    else if(a.getOwner() == ergos && !squad3.contains(a) && (a instanceof SuicideBaby || a instanceof FlamethrowerBaby))
                    {
                        squad3.add(a);
                        if(a.getAssignedRow() == 12)
                        {
                            reserve.get(2).add(a);
                        }
                    }
                    else if(a.getOwner() == ergos && !squad4.contains(a) && (a instanceof TroopCarrier))
                    {
                        squad4.add(a);
                        if(a.getAssignedRow() == 12)
                        {
                            reserve.get(3).add(a);
                        }
                    }
                }
            }
            if(faction == PosterityofSentinels)
            {
            }
        }
        catch(java.lang.IllegalStateException e)
        {
        }
    }    

    public void advance()
    {
        int a = 0;
        int b = 0;
        //Used requirements to count only finished structures
        for(int i = 0; i < 30; i ++)
        {
            a = ergos.Requirements[i];
            b = requiredStructures[i];
            if(a >= b)
            {
                argh.add(true);
            }
            else
            {
                argh.clear();
            }
        }  
        if(argh.size() >= 30)
        {
            try
            {
                for(boolean e : argh)
                {
                    if(e == false)
                    {
                        argh.remove(e);
                        argh.clear();
                        newargh.clear();
                    }
                    else
                    {
                        newargh.add(e);
                    }
                    if(newargh.size() >= 30)
                    {
                        argh.clear();
                        if(faction == TerritorialIndependenceArmy)
                        {
                            switch(behavior)
                            {
                                //Standard
                                case 1:
                                switch(com)
                                {
                                    case 0: requiredStructures[1] ++; requiredUnits[9] += 2; com = 1; newargh.clear(); break;
                                    case 1: requiredStructures[2] += 2; com = 2; newargh.clear(); break;
                                    case 2: requiredStructures[3] ++; com = 3; newargh.clear(); break;
                                    case 3: requiredStructures[2] ++; com = 4; newargh.clear(); break;
                                    case 4: requiredStructures[1] ++; requiredUnits[9] += 2; com = 5; newargh.clear(); break;
                                    case 5: requiredStructures[5] ++; com = 6; newargh.clear(); break;
                                    case 6: requiredStructures[4] ++; com = 7; newargh.clear(); break;
                                    case 7: requiredStructures[5] ++; com = 8; newargh.clear(); break;
                                }
                                break;
                                //Hovercycle Rusher
                                case 2:
                                switch(com)
                                {
                                    case 0: requiredStructures[1] ++; requiredUnits[9] += 2; com = 1; newargh.clear(); break;
                                    case 1: requiredStructures[3] ++; com = 2; newargh.clear(); break;
                                    case 2: requiredStructures[1] ++; com = 3; newargh.clear(); break;
                                    case 3: requiredStructures[3] ++; requiredUnits[9] += 2; com = 4; newargh.clear(); break;
                                    case 4: requiredStructures[2] ++; com = 5; newargh.clear(); break;
                                    case 5: requiredStructures[4] ++; com = 6; newargh.clear(); break;
                                    case 6: requiredStructures[5] ++; com = 7; newargh.clear(); break;
                                    case 7: requiredStructures[3] ++; com = 8; newargh.clear(); break;
                                }
                                break;
                                //Infantry Horde
                                case 3:
                                switch(com)
                                {
                                    case 0: requiredStructures[1] ++; requiredUnits[9] += 2; com = 1; newargh.clear(); break;
                                    case 1: requiredStructures[2] += 2; com = 2; newargh.clear(); break;
                                    case 2: requiredStructures[3] ++; com = 3; newargh.clear(); break;
                                    case 3: requiredStructures[1] ++; com = 4; newargh.clear(); break;
                                    case 4: requiredStructures[2] ++; requiredUnits[9] += 2; com = 5; newargh.clear(); break;
                                    case 5: requiredStructures[4] ++; com = 6; newargh.clear(); break;
                                    case 6: requiredStructures[5] ++; com = 7; newargh.clear(); break;
                                    case 7: requiredStructures[2] += 2; com = 8; newargh.clear(); break;
                                }
                                break;
                            }
                        }
                        if(faction == EvilBabyCorporation)
                        {
                            //Dictates what units are made, but switch is used to account for AI type.
                            switch(behavior)
                            {
                                //Training
                                case 0:
                                switch(com)
                                {
                                    case 0: requiredStructures[6] ++; requiredUnits[18] += 2; com = 1; newargh.clear(); break;
                                    case 1: requiredStructures[7] ++; com = 2; newargh.clear(); break;
                                    case 2: requiredStructures[7] ++; requiredUnits[18] ++; com = 3; newargh.clear(); break;
                                    case 3: requiredStructures[8] ++; com = 4; newargh.clear(); break;
                                    case 4: requiredStructures[10] ++; com = 5; newargh.clear(); break;
                                }
                                break;
                                //Basic
                                case 1:
                                switch(com)
                                {
                                    case 0: requiredStructures[6] ++; requiredUnits[18] += 2; com = 1; newargh.clear(); break;
                                    case 1: requiredStructures[7] ++; com = 2; newargh.clear(); break;
                                    case 2: requiredStructures[7] ++; requiredUnits[18] ++; com = 3; newargh.clear(); break;
                                    case 3: requiredStructures[8] ++; com = 4; newargh.clear(); break;
                                    case 4: requiredStructures[6] ++; com = 5; newargh.clear(); break;
                                    case 5: requiredStructures[7] ++; requiredUnits[18] += 2; com = 6; newargh.clear(); break;
                                    case 6: requiredStructures[9] ++; com = 7; newargh.clear(); break;
                                    case 7: requiredStructures[10] ++; com = 8; newargh.clear(); break;
                                    case 8: requiredStructures[7] ++; requiredUnits[18] += 2; com = 9; newargh.clear(); break;
                                }
                                break;
                            }
                        }
                        if(faction == PosterityofSentinels)
                        {
                        }
                    }
                }
            }
            catch(java.util.ConcurrentModificationException f)
            {
            }
        }
    }

    public void advanceunit()
    {
        int a = 0;
        int b = 0;
        //Used requirements to count only finished structures
        for(int i = 0; i < 30; i ++)
        {
            a = units[i];
            b = requiredUnits[i];
            if(a >= b)
            {
                arghu.add(true);
            }
            else
            {
                arghu.clear();
            }
        }  
        if(arghu.size() >= 30)
        {
            try
            {
                for(boolean e : argh)
                {
                    if(e == false)
                    {
                        arghu.remove(e);
                        arghu.clear();
                        newarghu.clear();
                    }
                    else
                    {
                        newarghu.add(e);
                    }
                    if(newarghu.size() >= 30)
                    {
                        arghu.clear();
                        if(faction == TerritorialIndependenceArmy)
                        {
                            switch(behavior)
                            {
                                //Standard
                                case 1:
                                switch(comu)
                                {
                                    case 0: requiredUnits[1] += 4; comu = 1; newarghu.clear(); break;
                                    case 1: requiredUnits[2] += 2; comu = 2; if(side == 1){setSquadFront(1000, 0); setSquadFront(900, 1); setSquadFront(1400, 2); setSquadFront(1800, 3);} else{setSquadFront(3000, 0); setSquadFront(3100, 1); setSquadFront(2600, 2); setSquadFront(2200, 3);}; squadformation[0] = 3; squadformation[1] = 3; squadformation[2] = 3; squadformation[3] = 3; newarghu.clear(); break;
                                    case 2: requiredUnits[1] += 4; comu = 3; newarghu.clear(); break;
                                    case 3: requiredUnits[4] += 1; comu = 4; newarghu.clear(); break;
                                    case 4: requiredUnits[19] += 4; comu = 5; newarghu.clear(); break;
                                    case 5: requiredUnits[5] += 2; totatt = true; setDelay(1200); comu = 6; newarghu.clear(); break;
                                    case 6: if(delay == 0){attack(); comu = 7; newarghu.clear();}; break;
                                    case 7: requiredUnits[1] += 8; comu = 8; newarghu.clear(); break;
                                    case 8: requiredUnits[2] += 4; comu = 9; newarghu.clear(); break;
                                    case 9: requiredUnits[4] += 1; comu = 10; newarghu.clear(); break;
                                    case 10: requiredUnits[7] += 2; comu = 11; newarghu.clear(); break;
                                    case 11: requiredUnits[3] += 1; comu = 12; newarghu.clear(); break;
                                    case 12: requiredUnits[33] += 1; setDelay(2000); comu = 13; newarghu.clear(); break;
                                    case 13: if(delay == 0){attack(); comu = 14; newarghu.clear();}; break;
                                    case 14: requiredUnits[4] += 2; comu = 15; newarghu.clear(); break;
                                    case 15: requiredUnits[7] += 2; comu = 16; newarghu.clear(); break;
                                    case 16: requiredUnits[2] += 2; comu = 17; newarghu.clear(); break;
                                    case 17: requiredUnits[19] += 4; comu = 18; newarghu.clear(); break;
                                    case 18: requiredUnits[3] += 1; setDelay(2000); comu = 19; newarghu.clear(); break;
                                    case 19: if(delay == 0){attack(); comu = 20; newarghu.clear();}; break;
                                }
                                break;
                                //Hovercycle Rusher
                                case 2:
                                switch(comu)
                                {
                                    case 0: requiredUnits[19] += 4; comu = 1; if(side == 1){setSquadFront(1000, 0); setSquadFront(900, 1); setSquadFront(1100, 2); setSquadFront(1400, 3);} else{setSquadFront(3000, 0); setSquadFront(3100, 1); setSquadFront(2900, 2); setSquadFront(2600, 3);}; squadformation[0] = 3; squadformation[1] = 3; squadformation[2] = 3; squadformation[3] = 3; newarghu.clear(); break;
                                    case 1: requiredUnits[19] += 8; comu = 2; newarghu.clear(); break;
                                    case 2: requiredUnits[5] += 2; comu = 3; newarghu.clear(); break;
                                    case 3: requiredUnits[4] += 2; comu = 4; newarghu.clear(); break;
                                    case 4: requiredUnits[19] += 4; comu = 5; newarghu.clear(); break;
                                    case 5: totatt = true; setDelay(600); comu = 6; newarghu.clear(); break;
                                    case 6: if(delay == 0){attack(); comu = 7; newarghu.clear();}; break;
                                    case 7: requiredUnits[19] += 4; comu = 8; newarghu.clear(); break;
                                    case 8: requiredUnits[1] += 4; comu = 9; newarghu.clear(); break;
                                    case 9: requiredUnits[2] += 4; comu = 10; newarghu.clear(); break;
                                    case 10: requiredUnits[7] += 6; comu = 11; newarghu.clear(); break;
                                    case 11: requiredUnits[19] += 4; comu = 12; newarghu.clear(); break;
                                    case 12: requiredUnits[33] += 1; setDelay(1000); comu = 13; newarghu.clear(); break;
                                    case 13: if(delay == 0){attack(); comu = 14; newarghu.clear();}; break;
                                    case 14: requiredUnits[4] += 2; comu = 15; newarghu.clear(); break;
                                    case 15: requiredUnits[7] += 2; comu = 16; newarghu.clear(); break;
                                    case 16: requiredUnits[2] += 2; comu = 17; newarghu.clear(); break;
                                    case 17: requiredUnits[19] += 4; comu = 18; newarghu.clear(); break;
                                    case 18: requiredUnits[3] += 1; setDelay(2000); comu = 19; newarghu.clear(); break;
                                    case 19: if(delay == 0){attack(); comu = 20; newarghu.clear();}; break;
                                }
                                break;
                            }
                        }
                        if(faction == EvilBabyCorporation)
                        {
                            //Dictates what units are made, but switch is used to account for AI type.
                            switch(behavior)
                            {
                                case 0:
                                switch(comu)
                                {
                                    case 0: requiredUnits[10] += 3; comu = 1; newarghu.clear(); break;
                                    case 1: requiredUnits[11] += 2; comu = 2; newarghu.clear(); break;
                                    case 2: requiredUnits[10] += 3; comu = 3; setSquadFront(3000, 0); setSquadFront(3100, 1); squadformation[0] = 3; squadformation[1] = 3; newarghu.clear(); break;
                                    case 3: requiredUnits[10] += 3; comu = 4; newarghu.clear(); break;
                                    case 4: requiredUnits[10] += 6; comu = 5; newarghu.clear(); break;
                                    case 5: requiredUnits[12] += 2; totatt = true; setDelay(6000); comu = 6; newarghu.clear(); break;
                                    case 6: if(delay == 0){attack(); comu = 7; newarghu.clear();}; break;
                                }
                                break;
                                case 1:
                                switch(comu)
                                {
                                    case 0: requiredUnits[10] += 6; comu = 1; newarghu.clear(); break;
                                    case 1: requiredUnits[11] += 4; comu = 2; newarghu.clear(); break;
                                    case 2: requiredUnits[10] += 6; comu = 3; if(side == 1){setSquadFront(1000, 0); setSquadFront(900, 1); setSquadFront(1400, 2);} else{setSquadFront(3000, 0); setSquadFront(3100, 1); setSquadFront(2600, 2);}; squadformation[0] = 3; squadformation[1] = 3; squadformation[2] = 3; newarghu.clear(); break;
                                    case 3: requiredUnits[10] += 6; comu = 4; newarghu.clear(); break;
                                    case 4: requiredUnits[10] += 6; comu = 5; newarghu.clear(); break;
                                    case 5: requiredUnits[12] += 6; totatt = true; setDelay(600); comu = 6; newarghu.clear(); break;
                                    case 6: if(delay <= 0){attack(); comu = 7; newarghu.clear();}; break;
                                    case 7: requiredUnits[11] += 4; comu = 8; newarghu.clear(); break;
                                    case 8: requiredUnits[14] += 2; comu = 9; newarghu.clear(); break;
                                    case 9: requiredUnits[17] += 2; comu = 10; newarghu.clear(); break;
                                    case 10: requiredUnits[16] += 8; comu = 11; newarghu.clear(); break;
                                    case 11: requiredUnits[10] += 9; comu = 12; newarghu.clear(); break;
                                    case 12: requiredUnits[12] += 4; setDelay(2000); comu = 13; newarghu.clear(); break;
                                    case 13: if(delay == 0){attack(); comu = 14; newarghu.clear();}; break;
                                    case 14: requiredUnits[12] += 3; comu = 15; newarghu.clear(); break;
                                    case 15: requiredUnits[17] += 3; comu = 16; newarghu.clear(); break;
                                    case 16: requiredUnits[14] += 3; comu = 17; setDelay(1200); newarghu.clear(); break;
                                    case 17: if(delay == 0){attack(); comu = 18; newarghu.clear();}; break;
                                }
                                break;
                            }
                        }
                        if(faction == PosterityofSentinels)
                        {
                        }
                    }
                }
            }
            catch(java.util.ConcurrentModificationException f)
            {
            }
        }
    }

    /**
     * Sets the main base for the AI.
     */
    public void setMainBase(int x, int y)
    {
        mainbase[0] = x;
        mainbase[1] = y;
    }

    /**
     * The method for setting up squads into battle line. 
     */
    public void drawBattleLine()
    {
        checkReserve();
        for(Units a : attackSquad)
        {
            if(a.getAction() != 3)
            {
                a.setBehavior(1);
            }
        }
        for(Units a : squad1)
        {
            if(a.getAssignedRow() != 12)
            {
                if(reserve.get(0).contains(a))
                {
                    reserve.get(0).remove(a);
                }
                if(!r.get(a.getAssignedRow()).get(0).contains(a))
                {
                    r.get(a.getAssignedRow()).get(0).add(a);
                }
                try
                {
                    //If statement to prevent shuffling of insufficient units.
                    if((reserve.get(0).size() > 0 || r.get(a.getAssignedRow()).get(0).size() > avgsize[0]) && r.get(leastrow[0]).get(0).size() < r.get(a.getAssignedRow()).get(0).size())
                    {
                        r.get(a.getAssignedRow()).get(0).remove(a);
                        a.assignRow(leastrow[0]);
                        if(!r.get(a.getAssignedRow()).get(0).contains(a))
                        {
                            r.get(a.getAssignedRow()).get(0).add(a);
                        }
                    }
                }
                catch(IndexOutOfBoundsException e)
                {
                }
            }
            if(a.getAssignedRow() == 12)
            {
                a.assignRow(leastrow[0]);
                if(!r.get(a.getAssignedRow()).get(0).contains(a))
                {
                    r.get(a.getAssignedRow()).get(0).add(a);
                }
            }
            for(int v = 0; v < 11; v ++)
            {
                if((r.get(v)).get(0).contains(a) && v != a.getAssignedRow() || a.getWorld() == null)
                {
                    r.get(v).get(0).remove(a);
                }
            }
            if(a.getAction() != 3 && a.getAction() != 4 && a.getAction() != 5 && a.realX() > squadorderx[0] + 20 && !attackSquad.contains(a) && !a.underAttack())
            {
                switch(side)
                {
                    case 1: a.setBehavior(2); break;
                    case 2: a.setBehavior(1); break;
                }
            }
            else if(a.getAction() != 3 && a.getAction() != 4 && a.getAction() != 5 && a.realX() < squadorderx[0] - 20 && !attackSquad.contains(a) && !a.underAttack())
            {
                switch(side)
                {
                    case 1: a.setBehavior(1); break;
                    case 2: a.setBehavior(2); break;
                }
            }
            else
            {
                if(squadformation[0] == 3)
                {
                    if(a.getRow() > a.getAssignedRow() && a.getAssignedRow() != 12)
                    {
                        if(a.getTrans() <= 0)
                        {
                            a.setVerticalTranslation(a.getImage().getHeight());
                            a.setBehavior(4);
                        }
                    }
                    if(a.getRow() < a.getAssignedRow() && a.getAssignedRow() != 12)
                    {
                        if(a.getTrans() <= 0)
                        {
                            a.setVerticalTranslation(a.getImage().getHeight());
                            a.setBehavior(5);
                        }
                    }
                }
            }
        }
        for(Units a : squad2)
        {
            if(a.getAssignedRow() != 12)
            {
                if(reserve.get(1).contains(a))
                {
                    reserve.get(1).remove(a);
                }
                if(!r.get(a.getAssignedRow()).get(1).contains(a))
                {
                    r.get(a.getAssignedRow()).get(1).add(a);
                }
                try
                {
                    //If statement to prevent shuffling of insufficient units.
                    if((reserve.get(1).size() > 0 || r.get(a.getAssignedRow()).get(1).size() > avgsize[1]) && r.get(leastrow[1]).get(1).size() < r.get(a.getAssignedRow()).get(1).size())
                    {
                        r.get(a.getAssignedRow()).get(1).remove(a);
                        a.assignRow(leastrow[1]);
                        if(!r.get(a.getAssignedRow()).get(1).contains(a))
                        {
                            r.get(a.getAssignedRow()).get(1).add(a);
                        }
                    }
                }
                catch(IndexOutOfBoundsException e)
                {
                }
            }
            if(a.getAssignedRow() == 12)
            {
                a.assignRow(leastrow[1]);
                if(!r.get(a.getAssignedRow()).get(1).contains(a))
                {
                    r.get(a.getAssignedRow()).get(1).add(a);
                }
            }
            for(int v = 0; v < 11; v ++)
            {
                if((r.get(v)).get(1).contains(a) && v != a.getAssignedRow() || a.getWorld() == null)
                {
                    r.get(v).get(1).remove(a);
                }
            }
            if(a.getAction() != 3 && a.getAction() != 4 && a.getAction() != 5 && a.realX() > squadorderx[1] + 20 && !attackSquad.contains(a) && !a.underAttack())
            {
                switch(side)
                {
                    case 1: a.setBehavior(2); break;
                    case 2: a.setBehavior(1); break;
                }
            }
            else if(a.getAction() != 3 && a.getAction() != 4 && a.getAction() != 5 && a.realX() < squadorderx[1] - 20 && !attackSquad.contains(a) && !a.underAttack())
            {
                switch(side)
                {
                    case 1: a.setBehavior(1); break;
                    case 2: a.setBehavior(2); break;
                }
            }
            else
            {
                if(squadformation[1] == 3)
                {
                    if(a.getRow() > a.getAssignedRow() && a.getAssignedRow() != 12 && !attackSquad.contains(a) && !a.underAttack())
                    {
                        if(a.getTrans() <= 0)
                        {
                            a.setVerticalTranslation(a.getImage().getHeight());
                            a.setBehavior(4);
                        }
                    }
                    if(a.getRow() < a.getAssignedRow() && a.getAssignedRow() != 12 && !attackSquad.contains(a) && !a.underAttack())
                    {
                        if(a.getTrans() <= 0)
                        {
                            a.setVerticalTranslation(a.getImage().getHeight());
                            a.setBehavior(5);
                        }
                    }
                }
            }
        }
        for(Units a : squad3)
        {
            if(a.getAssignedRow() != 12)
            {
                if(reserve.get(2).contains(a))
                {
                    reserve.get(2).remove(a);
                }
                if(!r.get(a.getAssignedRow()).get(2).contains(a))
                {
                    (r.get(a.getAssignedRow())).get(2).add(a);
                }
                try
                {
                    //If statement to prevent shuffling of insufficient units.
                    if((reserve.get(2).size() > 0 || r.get(a.getAssignedRow()).get(2).size() > avgsize[2]) && r.get(leastrow[2]).get(2).size() < r.get(a.getAssignedRow()).get(2).size())
                    {
                        r.get(a.getAssignedRow()).get(2).remove(a);
                        a.assignRow(leastrow[2]);
                        if(!r.get(a.getAssignedRow()).get(2).contains(a))
                        {
                            r.get(a.getAssignedRow()).get(2).add(a);
                        }
                    }
                }
                catch(IndexOutOfBoundsException e)
                {
                }
            }
            if(a.getAssignedRow() == 12)
            {
                a.assignRow(leastrow[2]);
                if(!r.get(a.getAssignedRow()).get(2).contains(a))
                {
                    r.get(a.getAssignedRow()).get(2).add(a);
                }
            }
            for(int v = 0; v < 11; v ++)
            {
                if((r.get(v)).get(2).contains(a) && v != a.getAssignedRow() || a.getWorld() == null)
                {
                    r.get(v).get(2).remove(a);
                }
            }
            if(a.getAction() != 3 && a.getAction() != 4 && a.getAction() != 5 && a.realX() > squadorderx[2] + 20 && !attackSquad.contains(a) && !a.underAttack())
            {
                switch(side)
                {
                    case 1: a.setBehavior(2); break;
                    case 2: a.setBehavior(1); break;
                }
            }
            else if(a.getAction() != 3 && a.getAction() != 4 && a.getAction() != 5 && a.realX() < squadorderx[2] - 20 && !attackSquad.contains(a) && !a.underAttack())
            {
                switch(side)
                {
                    case 1: a.setBehavior(1); break;
                    case 2: a.setBehavior(2); break;
                }
            }
            else
            {
                if(squadformation[2] == 3)
                {
                    if(a.getRow() > a.getAssignedRow() && a.getAssignedRow() != 12)
                    {
                        if(a.getTrans() <= 0)
                        {
                            a.setVerticalTranslation(a.getImage().getHeight());
                            a.setBehavior(4);
                        }
                    }
                    if(a.getRow() < a.getAssignedRow() && a.getAssignedRow() != 12)
                    {
                        if(a.getTrans() <= 0)
                        {
                            a.setVerticalTranslation(a.getImage().getHeight());
                            a.setBehavior(5);
                        }
                    }
                }
            }
        }
        for(Units a : squad4)
        {
            if(a.getAssignedRow() != 12)
            {
                if(reserve.get(3).contains(a))
                {
                    reserve.get(3).remove(a);
                }
                if(!r.get(a.getAssignedRow()).get(3).contains(a))
                {
                    r.get(a.getAssignedRow()).get(3).add(a);
                }
                try
                {
                    //If statement to prevent shuffling of insufficient units.
                    if((reserve.get(3).size() > 0 || r.get(a.getAssignedRow()).get(3).size() > avgsize[3]) && r.get(leastrow[3]).get(3).size() < r.get(a.getAssignedRow()).get(3).size())
                    {
                        r.get(a.getAssignedRow()).get(3).remove(a);
                        a.assignRow(leastrow[3]);
                        if(!r.get(a.getAssignedRow()).get(3).contains(a))
                        {
                            r.get(a.getAssignedRow()).get(3).add(a);
                        }
                    }
                }
                catch(IndexOutOfBoundsException e)
                {
                }
            }
            if(a.getAssignedRow() == 12)
            {
                a.assignRow(leastrow[3]);
                if(!r.get(a.getAssignedRow()).get(3).contains(a))
                {
                    r.get(a.getAssignedRow()).get(3).add(a);
                }
            }
            for(int v = 0; v < 11; v ++)
            {
                if((r.get(v)).get(3).contains(a) && v != a.getAssignedRow() || a.getWorld() == null)
                {
                    r.get(v).get(3).remove(a);
                }
            }
            if(a.getAction() != 3 && a.getAction() != 4 && a.getAction() != 5 && a.realX() > squadorderx[3] + 20 && !attackSquad.contains(a) && !a.underAttack())
            {
                switch(side)
                {
                    case 1: a.setBehavior(2); break;
                    case 2: a.setBehavior(1); break;
                }
            }
            if(a.getAction() != 3 && a.getAction() != 4 && a.getAction() != 5 && a.realX() < squadorderx[3] - 20  && !attackSquad.contains(a) && !a.underAttack())
            {
                switch(side)
                {
                    case 1: a.setBehavior(1); break;
                    case 2: a.setBehavior(2); break;
                }
            }
            else
            {
                if(squadformation[3] == 3)
                {
                    if(a.getRow() > a.getAssignedRow() && a.getAssignedRow() != 12)
                    {
                        if(a.getTrans() <= 0)
                        {
                            a.setVerticalTranslation(a.getImage().getHeight());
                            a.setBehavior(4);
                        }
                    }
                    if(a.getRow() < a.getAssignedRow() && a.getAssignedRow() != 12)
                    {
                        if(a.getTrans() <= 0)
                        {
                            a.setVerticalTranslation(a.getImage().getHeight());
                            a.setBehavior(5);
                        }
                    }
                }
            }
        }
        for(Units a : wa.Taxeis)
        {
            a.getRowPosition();
            for(int s = 0; s < 11; s ++)
            {
                if(leastrow[0] == 12)
                {
                    leastrow[0] = s;
                }
                try
                {
                    if(r.get(leastrow[0]).get(0).size() > r.get(s).get(0).size())
                    {
                        leastrow[0] = s;
                    }
                }
                catch(IndexOutOfBoundsException q)
                {
                }
                if(leastrow[1] == 12)
                {
                    leastrow[1] = s;
                }
                try
                {
                    if(r.get(leastrow[1]).get(1).size() > r.get(s).get(1).size())
                    {
                        leastrow[1] = s;
                    }
                }
                catch(IndexOutOfBoundsException q)
                {
                }
                if(leastrow[2] == 12)
                {
                    leastrow[2] = s;
                }
                try
                {
                    if(r.get(leastrow[2]).get(2).size() > r.get(s).get(2).size())
                    {
                        leastrow[2] = s;
                    }
                }
                catch(IndexOutOfBoundsException q)
                {
                }
                if(leastrow[3] == 12)
                {
                    leastrow[3] = s;
                }
                try
                {
                    if(r.get(leastrow[3]).get(3).size() > r.get(s).get(3).size())
                    {
                        leastrow[3] = s;
                    }
                }
                catch(IndexOutOfBoundsException q)
                {
                }
            }
        }
    }

    /**
     * Sets the desired x-coordinate of the squad battle line.
     */
    public void setSquadFront(int i, int g)
    {
        squadorderx[g] = i;
    }

    /**
     * Reascertain squad's average X value
     */
    public void refreshX()
    {
        for(int i = 0; i < squad1.size(); i ++)
        {
            x1 += squad1.get(i).realX();
            if(i >= squad1.size() - 1)
            {
                squadx[0] = (int)(x1/squad1.size());
                x1 = 0;
            }
        }
        for(int i = 0; i < squad2.size(); i ++)
        {
            x2 += squad2.get(i).realX();
            if(i >= squad2.size() - 1)
            {
                squadx[1] = (int)(x2/squad2.size());
                x2 = 0;
            }
        }
        for(int i = 0; i < squad3.size(); i ++)
        {
            x3 += squad3.get(i).realX();
            if(i >= squad3.size() - 1)
            {
                squadx[2] = (int)(x3/squad3.size());
                x3 = 0;
            }
        }
        for(int i = 0; i < squad4.size(); i ++)
        {
            x4 += squad4.get(i).realX();
            if(i >= squad4.size() - 1)
            {
                squadx[3] = (int)(x4/squad4.size());
                x4 = 0;
            }
        }
        if(squad1.size() + squad2.size() > 3*squad5.size() && squad1.size() + squad2.size() > 12)
        {
            int h = Greenfoot.getRandomNumber(squad1.size());
            {
                squad5.add(squad1.get(h));
                squad1.remove(squad1.get(h));
            }
            int i = Greenfoot.getRandomNumber(squad2.size());
            {
                squad5.add(squad2.get(i));
                squad2.remove(squad2.get(i));
            }
        }
    }

    /**
     * Checks the reserves, clearing out those that are assigned to a row.
     */
    public void checkReserve()
    {
        for(int i = 0; i < reserve.get(0).size(); i ++)
        {
            Units a = (Units) reserve.get(0).get(i);
            if(a.getAssignedRow() != 12)
            {
                reserve.get(0).remove(a);
            }
        }
        for(int i = 0; i < reserve.get(1).size(); i ++)
        {
            Units a = (Units) reserve.get(1).get(i);
            if(a.getAssignedRow() != 12)
            {
                reserve.get(1).remove(a);
            }
        }
        for(int i = 0; i < reserve.get(2).size(); i ++)
        {
            Units a = (Units) reserve.get(2).get(i);
            if(a.getAssignedRow() != 12)
            {
                reserve.get(2).remove(a);
            }
        }
        for(int i = 0; i < reserve.get(3).size(); i ++)
        {
            Units a = (Units) reserve.get(3).get(i);
            if(a.getAssignedRow() != 12)
            {
                reserve.get(3).remove(a);
            }
        }
    }

    /**
     * Takes the average size (and rounds it up or adds 1) that each row SHOULD be.
     */
    public void takeAverage()
    {
        switch(squadformation[0])
        {
            case 3: avgsize[0] = (int)(squad1.size() / 11f) + 1;
        }
        switch(squadformation[1])
        {
            case 3: avgsize[1] = (int)(squad2.size() / 11f) + 1;
        }
        switch(squadformation[2])
        {
            case 3: avgsize[2] = (int)(squad3.size() / 11f) + 1;
        }
        switch(squadformation[3])
        {
            case 3: avgsize[3] = (int)(squad4.size() / 11f) + 1;
        }
    }

    /**
     * Attack: If it is a total attack, ALL troops (including garrison) will be devoted to this attack, if not, it will take some (or all current nongarrison units, although with some only a few attacks.) and attack.
     */
    public void attack()
    {
        if(wa.gettut() == 5)
        {
            wa.addtut();
        }
        if(totatt)
        {
            for(Units a : squad1)
            {
                attackSquad.add(a);
            }
            for(Units a : squad2)
            {
                attackSquad.add(a);
            }
            for(Units a : squad3)
            {
                attackSquad.add(a);
            }
            for(Units a : squad4)
            {
                attackSquad.add(a);
            }
        }
        else
        {
        }
    }

    /**
     * Defend: Uses the garrison if any to repel enemy attackers.
     */
    public void defend()
    {
        for(Structures v : wa.Aedificium)
        {
            if(v.getOwner() == ergos)
            {
                if(v.underAttack())
                {
                    try
                    {
                        for(Units x : squad5)
                        {
                            if(x.intendedtarget == null)
                            {
                                x.intendedtarget = v.getAttacker();
                            }
                            else
                            {
                                if(x.getRow() > x.intendedtarget.getRow())
                                {
                                    if(x.getTrans() <= 0)
                                    {
                                        x.setVerticalTranslation(x.getImage().getHeight());
                                        x.setBehavior(4);
                                    }
                                }
                                if(x.getRow() < x.intendedtarget.getRow())
                                {
                                    if(x.getTrans() <= 0)
                                    {
                                        x.setVerticalTranslation(x.getImage().getHeight());
                                        x.setBehavior(5);
                                    }
                                }
                                else
                                {
                                    if(x.realX() > x.intendedtarget.realX())
                                    {
                                        switch(ergos.getSide())
                                        {
                                            case 1: x.setBehavior(8); break;
                                            case 2: x.setBehavior(1); break;
                                        }
                                    }
                                    if(x.realX() < x.intendedtarget.realX())
                                    {
                                        switch(ergos.getSide())
                                        {
                                            case 1: x.setBehavior(1); break;
                                            case 2: x.setBehavior(8); break;
                                        }
                                    }
                                }
                            }
                        }
                    }
                    catch(NullPointerException e)
                    {
                    }
                    catch(IllegalArgumentException e)
                    {
                    }
                    catch(IndexOutOfBoundsException e)
                    {
                    }
                }
            }
        }
    }

    public void setDelay(int del)
    {
        delay = del;
    }
}
