import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;

/**
 * The object that handles button creation for the user interface.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class ButtonCreator  extends Actor
{
    /**
     * The WorldArray Object that stores all sprites in game.
     */
    private WorldArray wa;
    /**
     * Order type (pertinent to structures, units, etc)
     */
    private int ordertype;
    /**
     * The ID of the command (e.g. move)
     */
    private int command;
    /**
     * the Array list that stores all the selected objects, presumably.
     */
    public ArrayList<DestructibleObjects> kalos = new ArrayList<DestructibleObjects>();
    /**
     * the Array list for the buttons.
     */
    private List<InGame> kakos;
    /**
     * checks if this should give orders.
     */
    private boolean check;
    /**
     * For checking for same type of unit
     */
    private boolean same;
    /**
     * Sees if there are different types of unit
     */
    private boolean terminate;
    public ButtonCreator(WorldArray ini)
    {
        wa = ini;
    }
    /**
     * Checks the world for buttons, and adds it to the kakos array list. Then it checks the wa's array lists for selected objects to add to the
     * kalos array list, then if the kalos array list size is greater than 1, checks for structures and removes all other objects.
     * Gives orders to units as well. If a button is pressed (which changes the value of the ordertype and command values), the order is distributed
     * to all the units selected.
     */
    public void act() 
    {
        // Add your action code here.
        readKeyboardKey();
        if(terminate)
        {
            terminate = false;
        }
        kakos = getWorld().getObjects(InGame.class);
        if(wa != null)
        {
            for(DestructibleObjects a : wa.Actors)
            {
                if(a.selected && !kalos.contains(a))
                {
                    kalos.add(a);
                }
            }
        }
        if(kalos.size() > 0)
        {
            if(kalos.size() > 1)
            {
                for(int i = 0; i < kalos.size(); i ++)
                {
                    if(kalos.get(i) instanceof Structures)
                    {
                        Structures a = (Structures) kalos.get(i);
                        kalos.remove(a);
                        for(int j = 0; j < kalos.size(); j++)
                        {
                            kalos.get(j).deselect();
                            kalos.remove(kalos.get(j));
                        }
                        kalos.add(a);
                    }
                    try
                    {
                    if(kalos.get(i) instanceof VolunteerSphere)
                    {
                    for(int z = 0; z < kalos.size(); z++)
                    {
                        DestructibleObjects n = kalos.get(z);
                        if(!terminate)
                        {
                            if(wa.TaxeisUniv.get(1).contains(n))
                            {
                                same = true;
                            }
                            else if(!(wa.TaxeisUniv.get(1).contains(n)))
                            {
                                same = false;
                                terminate = true;
                                createStandardButtons();
                            }
                            if(same && !terminate && z == kalos.size() - 1)
                            {
                                createStandardButtons();
                                createVolunteerSphereButton();
                            }
                        }
                    }
                    }
                    else
                    {
                        createStandardButtons();
                    }
                }
                catch(java.lang.IndexOutOfBoundsException e)
                {
                    createStandardButtons();
                }
            }
        }
            else if (kalos.size() == 1)
            {
                if(kalos.get(0) instanceof Units)
                {   
                    if(kalos.get(0) instanceof WorkerBaby)
                    {
                        createStandardButtons();
                        createWorkerBabyButtons();
                    }
                    else if(kalos.get(0) instanceof VolunteerSphere)
                    {
                        createStandardButtons();
                        createVolunteerSphereButton();
                    }
                    else if(kalos.get(0) instanceof Ninja)
                    {
                        createStandardButtons();
                        createNinjaButton();
                    }
                    else if(kalos.get(0) instanceof OfficerSphere)
                    {
                        createStandardButtons();
                        createOfficerButton();
                    }
                    else
                    {
                        createStandardButtons();
                    }
                }
                else
                {
                    if(kalos.get(0) instanceof ConstructionYard)
                    {
                        createConstructionButtons();
                    }
                    if(kalos.get(0) instanceof Dojo)
                    {
                        createDojoButtons();
                    }
                    if(kalos.get(0) instanceof Airfield)
                    {
                        createAirfieldButtons();
                    }
                    if(kalos.get(0) instanceof TIAWarFactory)
                    {
                        createTIAVehicleButtons();
                    }
                    if(kalos.get(0) instanceof StrategyCenter)
                    {
                        createStrategyCenterButtons();
                    }
                    if(kalos.get(0) instanceof Refinery)
                    {
                        createTIARefineryButtons();
                    }
                    if(kalos.get(0) instanceof EBCRefinery)
                    {
                        EBCRefinery d = (EBCRefinery) kalos.get(0);
                        if(d.getOperational())
                        {
                            createEBCRefineryButton();
                        }
                    }
                    if(kalos.get(0) instanceof BabyCamp)
                    {
                        BabyCamp d = (BabyCamp) kalos.get(0);
                        if(d.getOperational())
                        {
                            createBabyCampButtons();
                        }
                    }
                    if(kalos.get(0) instanceof EBCFactory)
                    {
                        EBCFactory d = (EBCFactory) kalos.get(0);
                        if(d.getOperational())
                        {
                            createEBCFactoryButtons();
                        }
                    }
                    if(kalos.get(0) instanceof CapitalistLodge)
                    {
                        CapitalistLodge d = (CapitalistLodge) kalos.get(0);
                        if(d.getOperational())
                        {
                            createCapitalistLodgeButtons();
                        }
                    }
                    if(kalos.get(0) instanceof MaterialistHub)
                    {
                        MaterialistHub d = (MaterialistHub) kalos.get(0);
                        if(d.getOperational())
                        {
                            createMaterialistHubButtons();
                        }
                    }
                    if(kalos.get(0) instanceof PosterityConstructionHub)
                    {
                        createPosterityConstructionButtons();
                    }
                    if(kalos.get(0) instanceof PosterityRefinery)
                    {
                        createPosterityRefineryButtons();
                    }
                    if(kalos.get(0) instanceof Airstrip)
                    {
                        createAirstripButtons();
                    }
                    if(kalos.get(0) instanceof Helipad)
                    {
                        createHelipadButtons();
                    }
                    if(kalos.get(0) instanceof CommandPost)
                    {
                        createCommandPostButtons();
                    }
                    if(kalos.get(0) instanceof NanoassemblyMainframe)
                    {
                        createNanoassemblyMainframeButtons();
                    }
                    if(kalos.get(0) instanceof MissileLaunchPad)
                    {
                        createMissileLaunchPadButtons();
                    }
                }
            }
        }
        if(kalos.size() == 0)
        {
            ordertype = 0;
            command = 0;
            kakos.clear();
            getWorld().removeObjects(getWorld().getObjects(Buttons.class));
        }
        if((ordertype != 0 || command != 0) && kalos.size() > 0)
        {
            for(Structures a : wa.Aedificium)
            {
                if(kalos.contains(a))
                {
                    a.deselect();
                    kalos.remove(a);
                }
                else if(kalos.size() > 0)
                {
                    if(ordertype == 4)
                    {
                        for(DestructibleObjects b : kalos)
                        {
                            if(((b.getAction() == 2 || b.getAction() == 8) && (command != 2 || command != 8)) || ((b.getAction() != 2 || b.getAction() != 8) && (command == 2 || command == 8)))
                            {
                                b.changealignment = true;
                            }
                            b.setBehavior(command);
                            b.needchange = true;
                            b.setPBehavior(command);
                            if(command == 4 || command == 5)
                            {
                                b.setVerticalTranslation(b.getImage().getHeight());
                            }
                        }
                        ordertype = 0;
                        command = 0;
                    }
                }
            }

        }
        for(int i = 0; i < kalos.size(); i ++)
        {
            if(!kalos.get(i).selected || kalos.get(i).getWorld() == null)
            {
                kalos.remove(kalos.get(i));
            }
        }
        if(Greenfoot.mousePressed(null))
        {
            MouseInfo ms = Greenfoot.getMouseInfo();
            if(ms.getButton() == 3)
            {
                check = false;
                try
                {
                for(DestructibleObjects a : kalos)
                {
                    a.deselect();
                    kalos.remove(a);
                }
                }
                catch(ConcurrentModificationException e)
                {
                    for(DestructibleObjects a : wa.Actors)
                    {
                        a.deselect();
                        kalos.clear();
                    }
                }
            }
            if(ms.getButton() == 1)
            {
                for(int i = 0; i < wa.Actors.size(); i ++)
                {
                    Actor a = wa.Actors.get(i);
                    if((ms.getX() >= a.getX() && ms.getX() <= a.getX() + a.getImage().getWidth()) && (ms.getY() >= a.getY() && ms.getY() <= a.getY() + a.getImage().getHeight()))
                    {
                        check = true;
                    }
                }
            }
        }
    }  
    /**
     * Creates standard buttons for units.
     */
    public void createStandardButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new UnitCommand(this,1), 656, 497);
            getWorld().addObject(new UnitCommand(this,2), 697, 497);
            getWorld().addObject(new UnitCommand(this,3), 738, 497);
            getWorld().addObject(new UnitCommand(this,8), 779, 497);
            getWorld().addObject(new UnitCommand(this,4), 656, 538);
            getWorld().addObject(new UnitCommand(this,5), 697, 538);
        }
    }
    /**
     * Creates button for Construction Yard (Territorial Independence Army)
     */
    public void createConstructionButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Structure(((ConstructionYard) kalos.get(0)),1), 656, 497);
            getWorld().addObject(new Structure(((ConstructionYard) kalos.get(0)),2), 697, 497);
            getWorld().addObject(new Structure(((ConstructionYard) kalos.get(0)),3), 738, 497);
            getWorld().addObject(new Structure(((ConstructionYard) kalos.get(0)),4), 779, 497);
            getWorld().addObject(new Structure(((ConstructionYard) kalos.get(0)),5), 656, 538);
            getWorld().addObject(new Structure(((ConstructionYard) kalos.get(0)),31), 738, 579);
            getWorld().addObject(new Structure(((ConstructionYard) kalos.get(0)),0), 779, 579);
        }
    }
    /**
     * Creates button for a Worker Baby (Evil Baby Corporation)
     */
    public void createWorkerBabyButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Structure(((WorkerBaby) kalos.get(0)),6), 738, 538);
            getWorld().addObject(new Structure(((WorkerBaby) kalos.get(0)),7), 779, 538);
            getWorld().addObject(new Structure(((WorkerBaby) kalos.get(0)),8), 656, 579);
            getWorld().addObject(new Structure(((WorkerBaby) kalos.get(0)),9), 697, 579);
            getWorld().addObject(new Structure(((WorkerBaby) kalos.get(0)),10), 738, 579);
        }
    }
    /**
     * Creates buttons for the Dojo (Territorial Independence Army)
     */
    public void createDojoButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),1), 656, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),2), 697, 497);
            if(kalos.get(0) instanceof Dojo && ((Dojo)kalos.get(0)).upgraded)
            {
                getWorld().addObject(new Unit(((Structures) kalos.get(0)),3), 738, 497);
                getWorld().addObject(new Unit(((Structures) kalos.get(0)),33), 779, 497);
            }
            getWorld().addObject(new Upgrade(2, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 656, 579);
            getWorld().addObject(new Upgrade(3, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 697, 579);
        }
    }
    /**
     * Creates buttons for the War Factory (Territorial Independence Army)
     */
    public void createTIAVehicleButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),4), 656, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),5), 697, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),6), 738, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),19), 779, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),31), 656, 538);
        }
    }
    /**
     * Creates buttons for the Airfield (Territorial Independence Army)
     */
    public void createAirfieldButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),7), 656, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),8), 697, 497);
            getWorld().addObject(new Stance(((Structures) kalos.get(0)),2), 697, 579);
            getWorld().addObject(new Stance(((Structures) kalos.get(0)),1), 656, 579);
        }
    }
    /**
     * Creates buttons for the Territorial Independence Army Refinery.
     */
    public void createTIARefineryButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),9), 656, 497);
        }
    }
    /**
     * Creates buttons for the Strategy Center (Territorial Independence Army)
     */
    public void createStrategyCenterButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Strike(1, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 656, 497);
            getWorld().addObject(new Upgrade(1, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 656, 579);
        }
    }
    /**
     * Adds a button to the Volunteer Sphere
     */
    public void createVolunteerSphereButton()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new UnitAbility(wa, 1, this), 656,  579);
        }
    }
    /**
     * Adds a button to the Ninja
     */
    public void createNinjaButton()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new UnitAbility(wa, 2, this), 656,  579);
        }
    }
    /**
     * Adds 2 buttons to the Officer Sphere
     */
    public void createOfficerButton()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new UnitAbility(wa, 3, this), 656,  579);
            getWorld().addObject(new UnitAbility(wa, 4, this), 697,  579);
        }
    }
    /**
     * Creates EBC Refinery Buttons
     */
    public void createEBCRefineryButton()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),18), 656,  497);
        }
    }
    /**
     * Creates EBC Baby Camp Buttons
     */
    public void createBabyCampButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),10), 656,  497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),11), 697,  497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),12), 738,  497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),13), 779,  497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),14), 656,  538);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),18), 697,  538);
        }
    }
    /**
     * Creates EBC Factory Buttons
     */
    public void createEBCFactoryButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),15), 656,  497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),16), 697,  497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),17), 738,  497);
        }
    }
    /**
     * Creates Capitalist Lodge Buttons
     */
    public void createCapitalistLodgeButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Strike(2, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 656, 497);
            getWorld().addObject(new Upgrade(4, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 697, 497);
            getWorld().addObject(new Upgrade(5, kalos.get(0).getOwner(), (Structures) kalos.get(0), 1), 738, 497);
        }
    }
    /**
     * Creates Materialist Hub Buttons
     */
    public void createMaterialistHubButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Strike(3, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 656, 497);
            getWorld().addObject(new Upgrade(6, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 697, 497);
            getWorld().addObject(new Upgrade(7, kalos.get(0).getOwner(), (Structures) kalos.get(0), 1), 738, 497);
        }
    }
    /**
     * Creates button for Construction Hub (Posterity)
     */
    public void createPosterityConstructionButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Structure(((PosterityConstructionHub) kalos.get(0)),11), 656, 497);
            getWorld().addObject(new Structure(((PosterityConstructionHub) kalos.get(0)),12), 697, 497);
            getWorld().addObject(new Structure(((PosterityConstructionHub) kalos.get(0)),13), 738, 497);
            getWorld().addObject(new Structure(((PosterityConstructionHub) kalos.get(0)),14), 779, 497);
            getWorld().addObject(new Structure(((PosterityConstructionHub) kalos.get(0)),15), 656, 538);
            getWorld().addObject(new Structure(((PosterityConstructionHub) kalos.get(0)),16), 697, 538);
            getWorld().addObject(new Structure(((PosterityConstructionHub) kalos.get(0)),31), 738, 579);
            getWorld().addObject(new Structure(((PosterityConstructionHub) kalos.get(0)),0), 779, 579);
        }
    }
    /**
     * Creates buttons for the Posterity of the Sentinels Refinery.
     */
    public void createPosterityRefineryButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),27), 656, 497);
        }
    }
    /**
     * Creates Airstrip buttons.
     */
    public void createAirstripButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),20), 656, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),21), 697, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),22), 738, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),25), 779, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),32), 656, 538);
        }
    }
    /**
     * Creates Airstrip buttons.
     */
    public void createMissileLaunchPadButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),30), 656, 497);
            getWorld().addObject(new Strike(8, ((Structures) kalos.get(0)).getOwner(),((Structures) kalos.get(0)), 0), 779, 497);
        }
    }
    /**
     * Creates buttons for the Helipad (Posterity)
     */
    public void createHelipadButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),24), 656, 497);
            getWorld().addObject(new Unit(((Structures) kalos.get(0)),23), 697, 497);
            getWorld().addObject(new Stance(((Structures) kalos.get(0)),2), 697, 579);
            getWorld().addObject(new Stance(((Structures) kalos.get(0)),1), 656, 579);
        }
    }
    /**
     * Creates buttons for the Command Post
     */
    public void createCommandPostButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            getWorld().addObject(new Strike(9, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 656, 497);
            getWorld().addObject(new Upgrade(8, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 697, 497);
            getWorld().addObject(new Upgrade(10, kalos.get(0).getOwner(), (Structures) kalos.get(0), 1), 738, 579);
        }
    }
    /**
     * Creates buttons for the Nanoassembly Mainframe
     */
    public void createNanoassemblyMainframeButtons()
    {
        if(kalos.size() > 0 && kakos.size() == 0)
        {
            //getWorld().addObject(new Strike(9, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 656, 497);
            getWorld().addObject(new Upgrade(9, kalos.get(0).getOwner(), (Structures) kalos.get(0), 0), 697, 497);
            //getWorld().addObject(new Upgrade(9, kalos.get(0).getOwner(), (Structures) kalos.get(0), 1), 638, 497);
        }
    }
    /**
     * sets the command for the button creator.
     * Parameter - type: The type of order, such as construction, unit behavior, strikes, etc.
     * Parameter - id: The id of the order beneath the command. 
     */
    public void giveOrder(int type, int id)
    {
        ordertype = type;
        command = id;
    }
    /**
     * Uses shortcut keys for easy command.
     */
    public void readKeyboardKey()
    {
        if(Greenfoot.isKeyDown("a"))
        {
            giveOrder(4,2);
        }
        if(Greenfoot.isKeyDown("d"))
        {
            giveOrder(4,1);
        }
        if(Greenfoot.isKeyDown("s"))
        {
            giveOrder(4,0);
        }
        if(Greenfoot.isKeyDown("w"))
        {
            giveOrder(4,4);
        }
        if(Greenfoot.isKeyDown("x"))
        {
            giveOrder(4,5);
        }
        if(Greenfoot.isKeyDown("z"))
        {
            giveOrder(4,8);
        }
        //if(Greenfoot.isKeyDown("e"))
        //{
        //    giveOrder(4,2);
        //}
    }
}
