import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.geom.*;

/**
 * The Disc Laser.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class DiscLaser  extends Weapons
{
    FloatingDisc base;
    private int cooldown;
    private GreenfootImage ximage;
    public DiscLaser(FloatingDisc home)
    {
        base = home;
        if(home.getGameHeight() > 0)
        {
            ximage = new GreenfootImage(8, home.getGameHeight());
        }
        else
        {
            ximage = new GreenfootImage(8, 1);
        }
        for(int h = 0; h < 4; h++)
        {
            ximage.setColor(new Color(0,215+(10*h),215+(10*h), 175+(20*h)));
            ximage.drawRect(h,0,8-h,home.getGameHeight());
        }
    }

    /**
     * Act - do whatever the DiscLaser wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        updateImage();
        if(!base.firing)
        {
            getWorld().removeObject(this);
        }
        else
        {
            if(base.firing && getWorld() != null)
            {
                height = base.getGameHeight() / 2;
                base.useEnergy(1);
                mapX = base.realX();
                mapY = base.realY();
            }
            if(cooldown > 0)
            {
                cooldown --;
            }
            if(cooldown < 0)
            {
                cooldown = 10;
            }
            try
            {
                Point2D.Double argh = new Point2D.Double(realX(), realY());
                for(DestructibleObjects a : wa.Actors)
                {
                    if(a.collisionBox().contains(argh) && cooldown <= 0 && a.getGameHeight() < 5)
                    {
                        if(a instanceof Structures)
                        {
                            Structures b = (Structures) a;
                            b.giveAttacker(base);
                        }
                        a.takedamage(3, 4);
                    }
                }
            }
            catch(NullPointerException e)
            {
            }    
        }
    }

    public void updateImage()
    {
        if(base.getGameHeight() > 0)
        {
            ximage = new GreenfootImage(8, base.getGameHeight());
        }
        else
        {
            ximage = new GreenfootImage(8, 1);
        }
        for(int h = 0; h < 4; h++)
        {
            ximage.setColor(new Color(0,215+(10*h),215+(10*h), 175+(20*h)));
            ximage.drawRect(h,0,8-h,base.getGameHeight());
        }
        setImage(ximage);
    }
}
