import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Frame per Second. All credit goes to mjrb4.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FPS  extends Interface
{
    private static final Color textColor = new Color(255, 0, 50);
    private static final String prefix = "FPS: ";
    private static final int updateFreq = 20;
    private long countAct;
    private long prevTime;
    private double fps;
    public FPS()
    {
        countAct = 0;
        setImage(new GreenfootImage(100, 16));
        GreenfootImage image = getImage();
        image.setColor(textColor);
        updateImage("-");
    }
/**
     * Set the value of the frames per second.
     * @param val the value to set the FPS to.
     */
    private void setFPS(Long val)
    {
        fps = val;
        updateImage(val.toString());
    }
    
    /**
     * Set the value of the frames per second.
     * @param val the value to set the FPS to.
     */
    private void setFPS(Double val)
    {
        fps = val;
        updateImage(val.toString());
    }
    
    /**
     * Get the number of frames per second.
     * @return the number of frames per second.
     */
    public double getFPS()
    {
        return fps;
    }
   
    
    /**
     * Calculate the FPS based on the mode, and
     * update the reading.
     */
    public void act()
    {
        countAct++;
            long gap = System.currentTimeMillis() - prevTime;
            if(gap != 0 && countAct%updateFreq==0) {
                countAct=0;
                setFPS((1.0/gap)*1000.0);
            }
            prevTime = System.currentTimeMillis();
    }

    /**
     * Draw the image.
     * @param value the FPS value
     */
    private void updateImage(String value)
    {
        GreenfootImage image = getImage();
        image.clear();
        image.drawString(prefix + value, 1, 12);
    }
  
}
