import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;

/**
 * The interface rectangle that comes out when a field support (or Strike) button is pressed. This is for determining how the field support will affect objects in game.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FieldSupportArea  extends Interface
{
    /**
     * Identification number of the field support. Determines not only area but effects as well.
     */
    private int ID;
    private WorldArray wa;
    private int tx;
    private int ty;
    private Player owner;
    private Structures base;
    public int occupyslot;
    public int cooldown;
    public FieldSupportArea(int ini, WorldArray cfg, Player argh, Structures stoa, int inislot)
    {
        ID = ini;
        wa = cfg;
        owner = argh;
        base = stoa;
        occupyslot = inislot;
        switch(ID)
        {
            case 1: cooldown = 1600; break;
            case 3: cooldown = 3000; break;
            case 9: cooldown = 1000; break;
        }
    }
    /**
     * Act - do whatever the FieldSupportArea wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        switch(ID)
        {
            case 1: tx = 200; ty = 100; break;
            case 3: tx = 300; ty = 200; break;
            case 8: tx = 400; ty = 200; break;
            case 9: tx = (int) wa.getWidth(); ty = 60; break;
        }
        GreenfootImage image = new GreenfootImage(tx, ty);
        image.setColor(Color.YELLOW);
        image.fillRect(0,0,tx,ty);
        image.setTransparency(100);
        setImage(image);
        try
        {
            if(wa.fsa == null)
            {
                wa.fsa = this;
            }
            MouseInfo ms = Greenfoot.getMouseInfo();
            setLocation(ms.getX(), ms.getY());
        }
        catch(IllegalStateException e)
        {
        }
        catch(NullPointerException e)
        {
        }
    }    
    public int getID()
    {
        return ID;
    }
    public int getWidth()
    {
        return tx;
    }
    public int getHeight()
    {
        return ty;
    }
    public List getPotentialTargets(java.lang.Class cls)
    {
        return getIntersectingObjects(cls);
    }
    public Structures getBase()
    {
        return base;
    }
    public Player getOwner()
    {
        return owner;
    }
}
