import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;

/**
 * Heavy anti-surface air unit of the Posterity. Its weapon is a close ranged weapon, 
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FloatingDisc  extends Flyer
{
    public boolean firing;
    private int energy = 1000;
    private boolean shielded;
    private DiscLaser laser = new DiscLaser(this);
    /**
     * By default this is enabled, which makes the disc open fire whenever there is a enemy.
     */
    private boolean autofire = true;
    /**
     * duration of overdride
     */
    private int overdrive;
    public FloatingDisc(int iniside, int ix, int iy)
    {
        side = iniside;
        maxhitpoints = 350;
        armortype = 3;
        armorquantity = 2;
        range = 40;
        hitpoints = 350;
        weapontype = 1;
        damage = 9;
        canhitground = true;
        flyer = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 300;
        height = 80;
    }
    public FloatingDisc(int iniside, Player pl, int ix, int iy)
    {
        owner = pl;
        side = iniside;
        maxhitpoints = 350;
        armortype = 3;
        armorquantity = 2;
        range = 40;
        hitpoints = 350;
        weapontype = 1;
        damage = 3;
        canhitground = true;
        flyer = true;
        speed = 2;
        mapX = ix;
        mapY = iy;
        cost = 300;
        height = 80;
    }
    public void addedToWorld(World w)
    {
        genmaches = (Battleground) w;
        wa = genmaches.array;
        needchange = true;
        id = 26;
    }
    /**
     * Act - do whatever the FloatingDisc wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        attacklaser();
        createHealthBar();
        perish();
        falldown();
        if(overdrive > 0)
        {
            overdrive --;
        }
        if(energy < 1000 && !firing)
        {
            energy ++;
        }
        if(getGameHeight() >= 40)
        {
            flyer = true;
        }
        else
        {
            flyer = false;
        }
    }    
    /**
     * Substitutes the method for attacking. Takes the concept of energy into account.
     * Unlike most units, this has a limiting factor, energy. O
     */
    public void attacklaser()
    {
        if(energy <= 0)
        {
            overdrive = 1500;
            firing = false;
        }
		if(overdrive > 0)
		{
			firing = false;
		}
        try
        {
        for(Buff a : buffs)
        {
            if(a.dur <= 0)
            {
                buffs.remove(a);
            }
            else
            {
                a.apply();
                a.dur --;
            }
        }
        }
        catch(java.util.ConcurrentModificationException e)
        {
        }
        List pot = wa.Actors;
        for(int i = 0; i < pot.size(); i++)
        {
            DestructibleObjects a = (DestructibleObjects) pot.get(i);
            if(a.hitpoints > 0 && (a.side != 6) && (a.getX() > attackParameter().getX() && a.getX() <= attackParameter().getX()+attackParameter().getWidth()) && (a.realY() > attackParameter().getY() && a.realY() <= attackParameter().getY()+attackParameter().getHeight()))
            {
                if((side == 1 && a.side == 2) || (side == 2 && a.side == 1) && ((canhitair && a.flyer)||(canhitground && !a.flyer)))
                {
                    target = a;
                }
            }
        }
        try
        {
            if(target.hitpoints > 0 && reload <= 0 && (target.getX() > attackParameter().getX() && target.getX() <= attackParameter().getX()+attackParameter().getWidth()) && (target.realY() > attackParameter().getY() && target.realY() <= attackParameter().getY()+attackParameter().getHeight()) && !target.flyer)
            {
                if(!firing && autofire && energy > 100 && overdrive <= 0)
                {
                    if(laser.getWorld() == null)
                    {
                        getWorld().addObject(laser, getX(), getY());
                    }
                    firing = true;
                }
            }
            if(target.hitpoints <= 0 || Math.sqrt(Math.pow(realX() - target.realX(),2) + Math.pow(realY() - target.realY(),2)) > 150 || target == null || (target.flyer && !canhitair) || (!target.flyer && !canhitground))
            {
                if(firing || overdrive > 0)
                {
                    firing = false;
                }
                target = null;
            }
        }
        catch(NullPointerException e)
        {
        }
    }
    /**
     * Fall down
     */
    public void falldown()
    {
        if(overdrive > 0)
        {
            if(height > 0)
            {
                height --;
            }
            if(unitaction != 0)
            {
                unitaction = 0;
            }
        }
    }
    /**
     * reduce energy
     */
    public void useEnergy(int ini)
    {
        energy -= ini;
    }
    public int getEnergy()
    {
        return energy;
    }
}
