import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Rectangle;
import java.awt.geom.*;
import java.util.List;
import java.util.ArrayList;

/**
 * Write a description of class GhostStructures here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class GhostStructures  extends Interface
{
    public int id;
    public ConstructionYard Com;
    public PosterityConstructionHub pch;
    public WorkerBaby eb;
    private boolean candeploy;
    private WorldArray wa;
    private OreMine nearest;
    public GhostStructures(int ini, ConstructionYard cfg, WorldArray dat)
    {
        id = ini;
        Com = cfg;
        wa = dat;
        switch(id)
        {
            case 1: setImage("RefineryGhost.png"); break;
            case 2: setImage("DojoGhost.png"); break;
            case 3: setImage("WarFactoryGhost.png"); break;
            case 4: setImage("AirfieldGhost.png"); break;
            case 5: setImage("StrategyCenterGhost.png"); break;
        }
    }
    public GhostStructures(int ini, WorkerBaby cfg, WorldArray dat)
    {
        id = ini;
        eb = cfg;
        wa = dat;
        switch(id)
        {
            case 6: setImage("RefineryGhost.png"); break;
            case 7: setImage("BabyCampGhost.png"); break;
            case 8: setImage("CapitalistLodgeGhost.png"); break;
            case 9: setImage("MaterialistHubGhost.png"); break;
            case 10: setImage("EBCWarFactoryGhost.png"); break;
        }
    }
    public GhostStructures(int ini, PosterityConstructionHub cfg, WorldArray dat)
    {
        id = ini;
        pch = cfg;
        wa = dat;
        switch(id)
        {
            case 11: setImage("RefineryGhost.png"); break;
            case 12: setImage("AirstripGhost.png"); break;
            case 13: setImage("CommandPostGhost.png"); break;
            case 14: setImage("HelipadGhost.png"); break;
            case 15: setImage("NanoassemblyMainframeGhost.png"); break;
            case 16: setImage("RocketLaunchPadGhost.png"); break;
        }
    }
    /**
     * Act - do whatever the GhostStructures wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        MouseInfo ms = Greenfoot.getMouseInfo();
        try
        {
        setLocation(ms.getX(), ms.getY());
        }
        catch(NullPointerException e)
        {
        }
        try
        {
            if(Greenfoot.mousePressed(null))
            {
                if(Com != null && ms.getButton() == 1 && getY() < 440)
                {
                    if(!candeploy)
                    {
                        getWorld().addObject(new ErrorText("Cannot Deploy Structure here! We need a better place to build, Comrade!", 250), 400, 400);
                    }
                    else if(candeploy)
                    {
                        Com.clearProduction();
                        switch(id)
                        {
                            case 1: getWorld().addObject(new Refinery(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                            case 2: getWorld().addObject(new Dojo(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                            case 3: getWorld().addObject(new TIAWarFactory(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                            case 4: getWorld().addObject(new Airfield(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                            case 5: getWorld().addObject(new StrategyCenter(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                        }
                    }
                }
                if(pch != null && ms.getButton() == 1 && getY() < 440)
                {
                    if(!candeploy)
                    {
                        getWorld().addObject(new ErrorText("We cannot deploy this structure here. Select a better place.", 250), 400, 400);
                    }
                    else if(candeploy)
                    {
                        pch.clearProduction();
                        switch(id)
                        {
                            case 11: getWorld().addObject(new PosterityRefinery(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                            case 12: getWorld().addObject(new Airstrip(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                            case 13: getWorld().addObject(new CommandPost(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                            case 14: getWorld().addObject(new Helipad(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                            case 15: getWorld().addObject(new NanoassemblyMainframe(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                            case 16: getWorld().addObject(new MissileLaunchPad(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()), getX(), getY()); getWorld().removeObject(this); break;
                        }
                    }
                }
                if(ms.getButton() == 3)
                {
                    getWorld().removeObject(this);
                }
                if(eb != null && ms.getButton() == 1 && getY() < 440)
                {
                    if(!candeploy)
                    {
                        getWorld().addObject(new ErrorText("We Cannot Build Structure here, great Overlord.", 250), 400, 400);
                    }
                    else if(candeploy)
                    {
                        switch(id)
                        {
                            case 6: EBCRefinery j = new EBCRefinery(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()); eb.targetbuilding = j; getWorld().addObject(j, getX(), getY()); getWorld().removeObject(this); break;
                            case 7: BabyCamp k = new BabyCamp(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()); eb.targetbuilding = k; getWorld().addObject(k, getX(), getY()); getWorld().removeObject(this); break;
                            case 8: CapitalistLodge l = new CapitalistLodge(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()); eb.targetbuilding = l; getWorld().addObject(l, getX(), getY()); getWorld().removeObject(this); break;
                            case 9: MaterialistHub m = new MaterialistHub(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()); eb.targetbuilding = m; getWorld().addObject(m, getX(), getY()); getWorld().removeObject(this); break;
                            case 10: EBCFactory n = new EBCFactory(((Battleground) getWorld()).thePlayer.getSide(), ((Battleground) getWorld()).thePlayer, getX() - ((Battleground) getWorld()).camerachange, getY()); eb.targetbuilding = n; getWorld().addObject(n, getX(), getY()); getWorld().removeObject(this); break;
                        }
                    }
                }
                if(ms.getButton() == 3)
                {
                    getWorld().removeObject(this);
                    //returns resources
                    if(eb != null)
                    {
                        switch(id)
                        {
                            case 6: eb.getOwner().resources += 175; break;
                            case 7: eb.getOwner().resources += 100; break;
                            case 8: eb.getOwner().resources += 150; break;
                            case 9: eb.getOwner().resources += 125; break;
                            case 10: eb.getOwner().resources += 250; break;
                        }
                    }
                }
            }
            try
            {
                List c = getIntersectingObjects(DestructibleObjects.class);
                if(c.size() > 0)
                {
                    getImage().setTransparency(150);
                    candeploy = false;
                }
                else if(c.size() == 0)
                {
                    if(id == 1 || id == 6 || id == 11)
                    {
                        for(OreMine b : wa.ResourceSource)
                        {
                            if(nearest == null)
                            {
                                nearest = b;
                            }
                            if(Math.sqrt(Math.pow(nearest.realX() - realX(), 2) + Math.pow(nearest.realY() - realY(), 2)) > Math.sqrt(Math.pow(b.realX() - realX(), 2) + Math.pow(b.realY() - realY(), 2)))
                            {
                                nearest = b;
                            }
                            if(Math.sqrt(Math.pow(nearest.realX() - realX(), 2) + Math.pow(nearest.realY() - realY(), 2)) < 200)
                            {
                                getImage().setTransparency(150);
                                candeploy = false;
                            }
                            else
                            {
                                if(pch != null)
                                {
                                    if(Math.sqrt(Math.pow(pch.realX() - (getX() - wa.getx()),2) + Math.pow(pch.realY() - getY(), 2)) > 700)
                                    {
                                        candeploy = false;
                                    }
                                    else
                                    {
                                        getImage().setTransparency(255);
                                        candeploy = true;
                                    }
                                }
                                else if(Com != null)
                                {
                                    if(Math.sqrt(Math.pow(Com.realX() - (getX() - wa.getx()),2) + Math.pow(Com.realY() - getY(), 2)) > 700)
                                    {
                                        candeploy = false;
                                    }
                                    else
                                    {
                                        getImage().setTransparency(255);
                                        candeploy = true;
                                    }
                                }
                                else
                                {
                                    getImage().setTransparency(255);
                                    candeploy = true;
                                }
                            }
                        }
                    }
                    else
                    {
                    getImage().setTransparency(255);
                    candeploy = true;
                    }
                }
            }
            catch(IllegalStateException e)
            {
            }
        }
        catch(NullPointerException e)
        {
        }
    }    
    public Rectangle2D.Double collisionBox()
    {
        return new Rectangle2D.Double(getX()-getImage().getWidth()/2, getY()-getImage().getHeight()/2, getImage().getWidth(), getImage().getHeight());
    }
    public int realX()
    {
        return getX() - wa.getx();
    }
    public int realY()
    {
        return getY();
    }
}
