import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Strike here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Strike  extends InGame
{
    private int id;
    private Player owner;
    private Structures origin;
    private int slot;
    private float cooldown;
    public Strike(int ini, Player cfg, Structures base, int inislot)
    {
        id = ini;
        owner = cfg;
        slot = inislot;
        origin = base;
        switch(id)
        {
            case 1: setImage("Nationalism.bmp"); cooldown = 1600; break;
            case 2: setImage("FreeSupplies.bmp"); cooldown = 2500; break;
            case 3: setImage("Ambush.bmp"); cooldown = 3000; break;
            case 4: setImage("AirStrike.bmp"); cooldown = 3000; break;
            case 5: setImage("CarpetBomb.bmp"); cooldown = 4000; break;
            case 6: setImage("ProtectiveDrone.bmp"); cooldown = 2000; break;
            case 7: setImage("OrbitalBombardment.bmp"); cooldown = 4000; break;
            case 8: setImage("ChemicalWarhead.bmp"); break;
            case 9: setImage("Fighter.bmp"); cooldown = 1000; break;
        }
    }
    /**
     * Act - do whatever the Strike wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        if(Greenfoot.mousePressed(this) && origin.buttoncooldown.get(slot) <= 0)
        {
            MouseInfo ms = Greenfoot.getMouseInfo();
                switch(id)
                {
                    case 1: getWorld().addObject(new FieldSupportArea(id, ((Battleground) getWorld()).array, owner, origin, slot), ms.getX(), ms.getY()); break;
                    case 2: origin.buttoncooldown.set(slot, (int) cooldown); owner.resources += 250; break;
                    case 3: getWorld().addObject(new FieldSupportArea(id, ((Battleground) getWorld()).array, owner, origin, slot), ms.getX(), ms.getY()); break;
                    case 8: MissileLaunchPad a = (MissileLaunchPad) origin; if(a.cw != null){getWorld().addObject(new FieldSupportArea(id, ((Battleground) getWorld()).array, owner, origin, slot), ms.getX(), ms.getY());} else{getWorld().addObject(new ErrorText("Build a Chemical Warhead.", 250), 400, 400);}; break;
                    case 9: getWorld().addObject(new FieldSupportArea(id, ((Battleground) getWorld()).array, owner, origin, slot), ms.getX(), ms.getY()); break;
                }
        }
        else if(origin.buttoncooldown.get(slot) > 0)
        {
            getImage().clear();
            switch(id)
            {
                case 1: setImage("Nationalism.bmp"); break;
                case 2: setImage("FreeSupplies.bmp"); break;
                case 3: setImage("Ambush.bmp"); break;
                case 4: setImage("AirStrike.bmp"); break;
                case 5: setImage("CarpetBomb.bmp"); break;
                case 6: setImage("ProtectiveDrone.bmp"); break;
                case 7: setImage("OrbitalBombardment.bmp"); break;
                case 9: setImage("Fighter.bmp"); break;
            }
            Color b = new Color(0,0,0,150);
            getImage().setColor(b);
            getImage().fillRect(0,0,(int)(getImage().getWidth() * (float)(origin.buttoncooldown.get(slot)/cooldown)), getImage().getHeight());
        }
        if(!hasbar)
        {
            makeHelpbar();
        }
    }    
    public void makeHelpbar()
    {
        if(!hasbar)
        {
        if(intersect())
        {
            switch(id)
            {
                case 1: getWorld().addObject(new HelpTab(this, "Nationalism", "Units in a small area attacks 25% faster.", "Cooldown: 1600 acts", "Affects player's units"), 650, 400); break;
                case 2: getWorld().addObject(new HelpTab(this, "Free Supplies", "Provides the player 250$", "Cooldown: 2500 acts", "Adds Money"), 650, 400); break;
                case 3: getWorld().addObject(new HelpTab(this, "Ambush", "Creates a randomized group of babies.", "Cooldown: 3000 acts", "Creates combat-purpose babies"), 650, 400); break;
                case 4: getWorld().addObject(new HelpTab(this, "Air Strike", "Sends a group of light bombers to drop bombs", "Cooldown: 3000 acts", "Precision Strike"), 650, 400); break;
                case 5: getWorld().addObject(new HelpTab(this, "Carpet Bombing", "Sends a heavy bomber to bomb an area.", "Cooldown: 4000 acts", "Devastation in large area"), 650, 400); break;
                case 6: getWorld().addObject(new HelpTab(this, "Protective Drones", "Protects vehicles in a small area with protective drones.", "Cooldown: 2000 acts", "Increases Durability"), 650, 400); break;
                case 7: getWorld().addObject(new HelpTab(this, "Orbital Bombardment", "Sends 3 explosive rods from a satellite.", "Cooldown: 4000 acts", "Attacks a medium area."), 650, 400); break;
                case 8: getWorld().addObject(new HelpTab(this, "Launch Warhead", "Launches a Chemical Warhead.", "Requires Chemical Warhead", "Attacks a large area."), 650, 400); break;
                case 9: getWorld().addObject(new HelpTab(this, "Send in Fighters", "Sends in Fighters to attack enemies.", "Upgrading the Radome provides benefits", "Fighters can be shot down."), 650, 400); break;
            }
            hasbar = true;
        }
        }
    }
}
